#ifndef _APPLICATION_H
#include <Application.h>
#endif	
#ifndef Main_WINDOW_H
#include "MainWindow.h"
#endif

#include "day.h"


MainWindow::MainWindow(BRect frame,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(frame, "What Went Wrong? It's a World Wide War!", 
				B_TITLED_WINDOW , B_ASYNCHRONOUS_CONTROLS) 
{



    SetPulseRate (DEFAULT_PULSE_RATE);

////////////////////////////////////////////////////////////////////////////
 
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id; 
	
	jour=compteur;
	
mb_height=10; //setté plus bas
buyWindow=NULL;
setWindow=NULL;
speedWindow=NULL;
editWindow=NULL;
menubar=NULL;
paintmode=NULL;
e_view=NULL;
scroll_view=NULL;
inside_view=NULL;
h_view=NULL;
power_view=NULL;
history_parent_view=NULL;
history_v_scroll=NULL;
panneau_load=NULL;
panneau_save=NULL;


//------------------------------------------------------------
	BRect rect;	  //variable de rectangle utilisée pour les diverses créations d'objets
//------------------------------------------------------------


	fprintf(stderr,"\nCreating Menu...");

///////////  ******************************************************
/// BARRE DE MENUS
///////// *******************************************************

	
	BMenu		*a_menu;  //objet sous-menu utilisé plusieurs fois pour la création des différents menus.
	BMenuItem	*item;    //utilisé par item coché par défaut (Options)
	//menubar et a_menu sont créés dans le .h pour utilisation (si on veut changer le menu
	Lock();

	menubar = new BMenuBar(rect, "MB");
	
	a_menu = new BMenu("Game");
	a_menu->AddItem(new BMenuItem("Start a new Game", new BMessage(MENU_GAME_RESTART)));
	a_menu->AddItem(new BMenuItem("Load Game", new BMessage(MENU_LOAD)));
	a_menu->AddItem(new BMenuItem("Save Game", new BMessage(MENU_SAVE)));
	
	a_menu->AddSeparatorItem();
	a_menu->AddItem(new BMenuItem("Set game speed", new BMessage(MENU_GAME_SET_DAY_RATE)));
	a_menu->AddItem(new BMenuItem("Edit Game", new BMessage(MENU_GAME_EDIT)));
	a_menu->AddItem(new BMenuItem("Pause", new BMessage(MENU_GAME_PAUSE)));
	a_menu->AddItem(new BMenuItem("Quit WW6", new BMessage(MENU_GAME_QUIT)));
	menubar->AddItem(a_menu);
	
	a_menu = new BMenu("Level");
	a_menu->AddItem(new BMenuItem("Easy", new BMessage(MENU_LEVEL_EASY)));
	a_menu->AddItem(item = new BMenuItem("Normal", new BMessage(MENU_LEVEL_NORMAL)));
	a_menu->AddItem(new BMenuItem("Hard", new BMessage(MENU_LEVEL_HARD)));
	a_menu->AddItem(new BMenuItem("Really, really, really, really, really too HARD", new BMessage(MENU_LEVEL_TOO_HARD)));
	a_menu->SetRadioMode(TRUE);//pour avoir un menu d'options à choix (coche)
	item->SetMarked(TRUE);//met la coche sur celui par défaut
	menubar->AddItem(a_menu); //rajoute le menu à la barre

//----------------------------------------

	jour->edit_menu = new BMenu("Edit");
	jour->edit_menu->AddItem(new BMenuItem("Scenario settings", new BMessage(MENU_SCENARIO)));
	jour->edit_menu->AddItem(paintmode = new BMenuItem("Paint Mode", new BMessage(MENU_PAINT_MODE)));
	jour->edit_menu->AddItem(new BMenuItem("Edit politics", new BMessage(MENU_POLITIC)));
	jour->edit_menu->AddSeparatorItem();
	jour->edit_menu->AddItem(new BMenuItem("Refresh Map (Multiply)", new BMessage(MENU_EDIT_REFRESH)));
	menubar->AddItem(jour->edit_menu);
	jour->edit_menu->SetEnabled(false);

	a_menu = new BMenu("Options");
	a_menu->AddItem(new BMenuItem("Don't log resistance attacks", new BMessage(LOG_IMPORTANT_MESSAGES)));
	a_menu->SetRadioMode(TRUE);//pour avoir un menu d'options à choix (coche)
	menubar->AddItem(a_menu); //rajoute le menu à la barre

	a_menu = new BMenu("Zoom");
	a_menu->AddItem(new BMenuItem("200%", new BMessage(ZOOM_200)));
	a_menu->AddItem(new BMenuItem("150%", new BMessage(ZOOM_150)));
	a_menu->AddItem(new BMenuItem("100%", new BMessage(ZOOM_100)));
	a_menu->AddItem(new BMenuItem("75%", new BMessage(ZOOM_75)));
	a_menu->AddItem(new BMenuItem("50%", new BMessage(ZOOM_50)));
	
	a_menu->SetRadioMode(TRUE);//pour avoir un menu d'options à choix (coche)
	menubar->AddItem(a_menu); //rajoute le menu à la barre

	
	a_menu = new BMenu("Help");
	a_menu->AddItem(item = new BMenuItem("Documentation...", new BMessage(MENU_DOC)));
	a_menu->AddSeparatorItem();
	a_menu->AddItem(item = new BMenuItem("About", new BMessage(MENU_ABOUT)));
	menubar->AddItem(a_menu); //rajoute le menu à la barre

	AddChild(menubar); //ajoute la barre de menus complète à la fenêtre
	

	fprintf(stderr,"\nMenu Added.");
	Unlock();//Lock nécessaire que pour barre menus

//FIN BARRE DE MENUS
// ********************************************************************
//  *********************************************************************

//CONSTRUCTIONS DES VUES

mb_height = menubar->Bounds().Height();

//-------------------------------------------------
// VUE INFORMATIONS SUR COUNTRY


	//Creation Vue INfos A gauche)


//-------------------------------------------------
// SCROLLVIEW AVEC BITMAP DEDANS
//-------------------------------------------------
#define POWER_HEIGHT 10

rect.Set(0,mb_height+1,WIN_X_SIZE,WIN_Y_SIZE-HISTORY_Y_SIZE-POWER_HEIGHT-3);



fprintf(stderr,"\nCreating MapView...");

inside_view = new MapView(rect, Ct_pointer,Grp_pointer,Pol_pointer,jour);

fprintf(stderr,"\nMapView OK");

//BView *bidon = new BView(BRect(0,0,200,200), "bidon", B_FOLLOW_ALL,B_WILL_DRAW);
//scroll_view = new BScrollView("scroll view", bidon, B_FOLLOW_ALL, B_WILL_DRAW,false,false);


//VERSION AVEC VIEW BIDON
//VERSION AVEC VIEW BIDON
//VERSION AVEC VIEW BIDON

fprintf(stderr,"\n-- Creating ScrollView...");

scroll_view = new BScrollView("scroll view", inside_view, B_FOLLOW_ALL_SIDES, B_WILL_DRAW,false,false);
scroll_view->SetViewColor(0,0,0);//pour pas trop flasher les yeux avant que le premier full multiply ait pu avoir eu lieu
								//ouais... faudrait surtout que la pic vide soit noire et pas blanche...	

fprintf(stderr,"\nScrollView OK.");

rect.top = rect.bottom;
rect.bottom = rect.top +POWER_HEIGHT+1;

fprintf(stderr,"\n-- Creating PowerView...");
power_view = new PowerView(BRect(rect),Ct_pointer,Grp_pointer,Pol_pointer,jour);
fprintf(stderr,"\nPowerView OK");



if (inside_view!=NULL)
{
fprintf(stderr,"\n-- Updating scrollbars...");
//j'utilise pas les scrollbar de la scrollviews car je veux pas les afficher..
//Or, même si je fais Hide, la barre du bas, voit son contour redessiné de temps en temps, ça fait buggé									
jour->scroll_hori  = new BScrollBar(BRect(inside_view->Bounds().Width(),0,B_V_SCROLL_BAR_WIDTH,0),
									"",inside_view,0,1000,B_HORIZONTAL);

jour->scroll_verti  = new BScrollBar(BRect(0,inside_view->Bounds().Height(),0,B_V_SCROLL_BAR_WIDTH),
									"",inside_view,0,1000,B_VERTICAL);


//le range de scroll est égal à la taille de la pic moins la partie affichée
//cette routine est refaite dans FrameResized à chaque modif de taille
jour->scroll_hori->SetRange(0, jour->map_x_size-(WIN_X_SIZE)); 
jour->scroll_verti->SetRange(0, jour->map_y_size-(WIN_Y_SIZE-mb_height-HISTORY_Y_SIZE)); 
}


fprintf(stderr,"\n-- Adding scrollview...");
AddChild(scroll_view); //ajoute la vue du texte à la window  
fprintf(stderr,"\n-- ScrollView added.");


fprintf(stderr,"\n-- Adding powerview...");

 	AddChild(power_view);

//-----------------------------------------------------------------------------------------------------------
	rect.Set(0,WIN_Y_SIZE-HISTORY_Y_SIZE,1280,WIN_Y_SIZE); //1280 pour être sûr
			 

fprintf(stderr,"\n-- Creating history parent view...");
	//history_parent_view englobe le texte et la barre de scroll vert			 
	history_parent_view = new BView(rect,"hparentview",B_FOLLOW_BOTTOM | B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW);
	history_parent_view->SetViewColor(216,216,216);

	BRect text_rect;
	//Creation vue History

	rect.Set(0,0, WIN_X_SIZE-B_V_SCROLL_BAR_WIDTH,HISTORY_Y_SIZE);	
	text_rect=rect;
	text_rect.InsetBy(16,16); //même rect en plus petit de 16

//DEBUG
//DEBUG
//DEBUG
//DEBUG
//WITH R5 ENABLING H_VIEW_CAUSES_CRASH_UNLESS RUN FROM BDB

fprintf(stderr,"\nCreating history view...");
	h_view = new HistoryView(rect, "hview", text_rect,jour);
fprintf(stderr,"\nHistoryView created OK");

//DEBUG
//DEBUG
//DEBUG
//DEBUG
	    
		//Création barre vertical de HistoryView
		rect.Set(WIN_X_SIZE-B_V_SCROLL_BAR_WIDTH+1,0, WIN_X_SIZE,HISTORY_Y_SIZE);	
   	    history_v_scroll= new BScrollBar(rect, "", h_view, 0, HISTORY_Y_SIZE-B_V_SCROLL_BAR_WIDTH, B_VERTICAL); 
	
	   	history_parent_view->AddChild(history_v_scroll);

	if (h_view!=NULL)
   	{
  		history_parent_view->AddChild(h_view); //ajoute la vue du texte à la window
	}
		
	AddChild(history_parent_view); //ajoute la vue du texte à la window

	fprintf(stderr,"\nMainWindow Contructor [finished]");
 
}

//----------------------------------------------------


//*********************************************************************
//*********************************************************************

//POUR LA GESTION DES MESSAGES ARRIVANT	
//Ca doit etre dans la main window... si c'est dans les view, seulement les views répondent
void MainWindow::MessageReceived(BMessage *message)
{

/*	
	//TEMP TEST
	//TEMP TEST
	//TEMP TESTf
	//TEMP TEST
	fprintf(stderr,"\nMainWindow messagereceived disabled");
	BWindow::MessageReceived(message);
	return;
*/	
	
	
	BRect la_zone;
	// Print the message to see its contents
//	message->PrintToStream();
	BAlert *xalert;

		
 	switch ( message->what ){

		case UPDATE_TITLE:
		if (inside_view!=NULL)
			inside_view->UpdateTitle();
		break;
		
		case UPDATE_POWER_BAR:
		if (power_view!=NULL)
		power_view->UpdateBar();
		break;
		
		case ZOOM_200:
		jour->zoom_level = 2;
		if (inside_view!=NULL)
		{
			inside_view->SetScale(2); 	PostMessage(REDRAW_ME);
			inside_view->ResizeTo(jour->map_x_size * jour->zoom_level,jour->map_x_size *jour->zoom_level );
		}
		break;
 	
 		case ZOOM_150:
		jour->zoom_level = 1.5;
		if (inside_view!=NULL)
		{
			inside_view->ResizeTo(jour->map_x_size * jour->zoom_level,jour->map_x_size *jour->zoom_level );
			inside_view->SetScale(1.5); 	PostMessage(REDRAW_ME);
 		}
 		break;
 	
 		case ZOOM_100:
		jour->zoom_level = 1;
		if (inside_view!=NULL)
		{
			inside_view->ResizeTo(jour->map_x_size * jour->zoom_level,jour->map_x_size *jour->zoom_level );
			inside_view->SetScale(1); 	PostMessage(REDRAW_ME);
 		}
 		break;
 	
 		case ZOOM_75:
		jour->zoom_level = 0.75;
		if (inside_view!=NULL)
		{
			inside_view->ResizeTo(jour->map_x_size * jour->zoom_level,jour->map_x_size *jour->zoom_level );
			inside_view->SetScale(0.75); 	PostMessage(REDRAW_ME);
 		}
 		break;
 	
 		case ZOOM_50:
		jour->zoom_level = 0.5;
		if (inside_view!=NULL)
		{
			inside_view->ResizeTo(jour->map_x_size * jour->zoom_level,jour->map_x_size *jour->zoom_level );
			inside_view->SetScale(0.5); 	PostMessage(REDRAW_ME);
 		}
 		break;
 	
 		case REDRAW_ME:
 		if (inside_view!=NULL)
			inside_view->Draw(Bounds());
 		break;
 		
 		case DRAW_ACTIVE_COUNTRY:
 		la_zone = 	Ct_pointer[jour->active_country]->limit;
   	  	if (inside_view!=NULL)
		{
   		  	inside_view->Multiply(la_zone); //multiplie la zone séléectionée par jour->zone
			inside_view->Draw(la_zone);
			inside_view->ShowSelect();
		}
		break;

   		
	
		case CT_NEXT:
		if (jour->active_country == jour->country_last) jour->active_country=jour->country_first;
		else jour->active_country++;
		jour->mainWin->PostMessage(SHOW_SELECT);
		jour->infoWin->PostMessage(DRAW_INFO);

	    break; 

 		case CT_PREV:
		if (jour->active_country == jour->country_first) jour->active_country=jour->country_last;
		else jour->active_country--; //si on peut pas faire la suivante on recommence
		if (jour->mainWin!=NULL)
			jour->mainWin->PostMessage(SHOW_SELECT);
		if (jour->infoWin!=NULL)
			jour->infoWin->PostMessage(DRAW_INFO);
	    break; 
 		
 		
	case MENU_EDIT_REFRESH:
	if (inside_view!=NULL)
		inside_view->MultiplyAll();
	break;		
	
	case MENU_POLITIC:
	//afficher fenetre edit politique
	NotImplemented();
	break;		
	
 	case MENU_GAME_EDIT:
		
		if (jour->edit_mode==OFF)
		{
		jour->edit_mode=ON;
		jour->pause=ON;
		jour->game_started=OFF;
		jour->jump_days=1; //sinon ça merde quand on ressort
		jour->edit_menu->SetEnabled(true);
		
		//CREER fenetre edit
		BRect rect;
		rect.Set(16,16,EDIT_X_SIZE-1, EDIT_Y_SIZE-1);
		editWindow = new EditWindow(rect,Ct_pointer,Grp_pointer,Pol_pointer,jour);
	    
	    editWindow ->Lock();		
		editWindow ->Show();		
		editWindow ->Unlock();		
		jour->mainWin->PostMessage(UPDATE_TITLE);
		
		}
		else
		{//sinon aucun effet   
		PostMessage(UPDATE_TITLE);
		
		}
		
		break; 
 	

   		case BUTTON_BUY:
		if (Grp_pointer[Ct_pointer[jour->active_country]->group]->player==COMPUTER) 
		{beep(); }
		else
		{
			buyWindow = new BuyWindow(Ct_pointer[jour->active_country],jour);
	    
		    buyWindow ->Lock();		
			buyWindow ->Show();		
			buyWindow ->Unlock();		
		}
		PostMessage(new BMessage(SHOW_SELECT));
		break;	
  
   		case BUTTON_SET:
   		if (Grp_pointer[Ct_pointer[jour->active_country]->group]->player==COMPUTER) 
		{beep(); }
		else
		{

		setWindow = new OrderWindow(Ct_pointer[jour->active_country],jour);
	    setWindow ->Lock();		
	    setWindow ->Show();		
	    setWindow ->Unlock();	
	    }	
	   	PostMessage(new BMessage(SHOW_SELECT));
		break;	
		

 		case SHOW_SELECT:
		if (inside_view!=NULL)
			inside_view->ShowSelect();
 		break;
 		 		
   		//MENUS GAME
		case MENU_GAME_RESTART:
		Restart();
		break;   

   	  	case MENU_LOAD:
   	  	if (panneau_load==NULL) 
   	  		{	jour->app_dir();
				
		  		 panneau_load = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false,true);
				 panneau_load->SetPanelDirectory(jour->dossier_app);
				 }
  		
   	  	panneau_load->Show();
   	  	break;
   	  	
		case MENU_SAVE:
   	  	if (panneau_save==NULL)
   	  		{	jour->app_dir();
		  		 panneau_save = new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false,true);
				 panneau_save->SetPanelDirectory(jour->dossier_app);
  	 		}
  	 	panneau_save->Show();
  		
   	  	break;
  		
/* 		 BFilePanel(file_panel_mode mode = B_OPEN_PANEL, 
         BMessenger* target = NULL, 
         entry_ref *panel_directory = NULL, 
         uint32 node_flavors = 0, 
         bool allow_multiple_selection = true, 
         BMessage *message = NULL, 
         BRefFilter *filter = NULL, 
         bool modal = false, 
         bool hide_when_done = true)
  */		
  		
  		
   	  	
		case MENU_GAME_SET_DAY_RATE:
		
		if (speedWindow==NULL)
			speedWindow = new SpeedWindow(jour);
	    
	    speedWindow ->Lock();	
	    speedWindow ->Show();	
	    speedWindow ->Unlock();	
	    
		break;   

		case B_QUIT_REQUESTED:
		case MENU_GAME_QUIT:
		be_app->Lock();
		be_app->PostMessage(B_QUIT_REQUESTED);
		be_app->Unlock(); //sinon ça plante	
		break;   
		
   		case MENU_GAME_PAUSE:
   		if (jour->pause==OFF)jour->pause=ON;
   		else {jour->pause=OFF; 
   		PostMessage(REDRAW_ME);
   		//inside_view->Draw(Bounds());}
		
		break;   

   		//MENUS LEVEL
   		case MENU_LEVEL_EASY:
   	  	jour->game_level=EASY;
   		break;   
		
		case MENU_LEVEL_NORMAL:
   	  	jour->game_level=NORMAL;
   		break;   

		case MENU_LEVEL_HARD:
   	  	jour->game_level=HARD;
   	   	break;   
   	   	
   	   	case MENU_LEVEL_TOO_HARD:
   		xalert = new BAlert("","YOU LOSE.\nSorry but you knew it was going to be hard!", "Exit!"); 
   		xalert->Go();
   	  	Restart();
   	  	break;
   	   	
   	   	case MENU_SCENARIO:
   	   	NotImplemented();
   	  	break;
   	  	
		
		case MENU_PAINT_MODE:
		if (jour->paint_mode==OFF)
			{ jour->paint_mode=ON;
			paintmode->SetLabel("BACK TO SELECT MODE");}
		else {jour->paint_mode=ON;
			 paintmode->SetLabel("Paint mode");
			 jour->paint_mode=OFF;}
   	  	break;	
   	  	
   	  	case LOG_IMPORTANT_MESSAGES:
   	 	 	if (jour->full_log == OFF) jour->full_log=ON;
 	  		else jour->full_log =OFF;  	
   	  	break;
   	  	
	
   	  	case MENU_ABOUT:
   	  	My_AboutBox();
   			break;   

	
   	  	case MENU_DOC: //on lance netpositive
   	  	OpenHelp();
   	  	break;   
 
		case MULTIPLY_RECT:
   	  	la_zone = message->FindRect("zone");
		if (inside_view!=NULL)
		{
	   	  	inside_view->Multiply(la_zone); //multiplie la zone séléectionée par jour->zone
			inside_view->Draw(la_zone);
		}
		break;

		case MULTIPLY_ALL:
		if (inside_view!=NULL)
			inside_view->MultiplyAll();
		break;
		

		case B_KEY_DOWN:
		ShortCuts(message);
		break;
		
	   	default:
   			// Call inherited if we didn't handle the message
   			BWindow::MessageReceived(message);

   			break;
   	
	}//fin switch;

//SI ON A UN ILLEGAL JUMP PAST INITIALIZER c'est à cause de case MENU_DOC
//be_roster->Launch... faut qu'il soit dans une fonction externe (c'est le cas maintenant)
}
}

//--------------------------------------


void MainWindow::My_AboutBox()
{
   BAlert *alert = new BAlert("WW6",
   "What Went Wrong? it's a World Wide War! V1.9\n\n© 1998-2003 by Santiago (Jacques) Lema\njacques@link-u.com\n http://lema.link-u.com/", 
   "Sucks!"); 
   alert->Go();

}

void MainWindow::NotImplemented()
{
   	  	BAlert *alert = new BAlert("","Sorry, still not Implemented","Oompf!");alert->Go();
 
}

void MainWindow::OpenHelp()
{
//si tu as envoies un message depuis le message received
//tu as un warning à la compilation (past initializer)
//donc faut une fonction, comme ici.

    	   jour->app_dir(); //met le dossier de l'app dans jour->dossier_app
		   char name[255];
		   char filename[255];
		   sprintf(name,jour->dossier_app); //recupere le nom en string ;-)pour le modifier
  		   sprintf(filename,"file://%s/help/index.html",name);

   	  	   BMessage urlmsg( B_ARGV_RECEIVED );
   	  	   urlmsg.AddString( "argv", "" );
   	  	   urlmsg.AddString( "argv",filename );
   	  	   urlmsg.AddInt32(  "argc", 2 );
   	  	   be_roster->Launch("application/x-vnd.Be-NPOS", &urlmsg );
   	
}


void MainWindow::FrameResized(float width, float height)
{

if (inside_view!=NULL)
{
	//set le v_rect pour le scroll
	inside_view->v_rect = Bounds();
	//inside_view->v_rect.left	/= jour->zoom_level;
	//inside_view->v_rect.right	/= jour->zoom_level;
	//inside_view->v_rect.top		/= jour->zoom_level;
	//inside_view->v_rect.bottom 	/= jour->zoom_level;

	inside_view->v_rect.right-= 0;
	inside_view->v_rect.bottom-= HISTORY_Y_SIZE;
}


//remet la taille possible des scrollbars au nécessaire
if (jour->scroll_hori!=NULL && jour->scroll_verti!=NULL)
{
	jour->scroll_hori->SetRange(0, jour->map_x_size-(width)); 
	jour->scroll_verti->SetRange(0, jour->map_y_size-(height-mb_height-HISTORY_Y_SIZE));
}

//-70 c'est la taille du toptxt dans infoview
jour->interligne = (uint16) ((height-70)/36);

if (jour->infoWin!=NULL)
jour->infoWin->PostMessage(DRAW_INFO);

}

 
void MainWindow::Restart()
{
   BAlert *alert = new BAlert("", 
                     "Are you sure you wish to start it all again?", 
                     "Cancel", "Do it"); 
   int32 button_index;

 
   switch(button_index = alert->Go())
   {
   //les boutons ont toujours les valeurs 0,1,2 (trois boutons max)
    case 1:
    alert = new BAlert("","Sorry, to start a new game you'll have to reload. This is a buggy program you know...","Oompf!");alert->Go();
 	break;
 	
	}

 
}


//-----------------------------------------------------------------


void MainWindow::ShortCuts(BMessage *msg)
 {
 
		   int8 bytes[3];
           int32 key;
           int32 modi;
           msg->FindInt32 ("modifiers", &modi); 
           msg->FindInt32 ("key", &key); 
           msg->FindInt8  ("byte", &bytes[0]); 
			//POUR KEYS SIMPLES

			if (modifiers() & B_SHIFT_KEY) 
				{
					        switch ( bytes[0] )
							{
			                	case B_TAB & B_SHIFT_KEY:	PostMessage(new BMessage(CT_PREV));  break; //en arrière
							}
			
				return; //sinon il fait les autres après
			
				}
			
			
	        switch ( bytes[0] )
            { //ON AVANCE de 10 à 100 %
                case B_TAB:					PostMessage(new BMessage(CT_NEXT));  break; //en avant
                
           		case 'b': 
				PostMessage(new BMessage(BUTTON_BUY));
           		break; 

           		case 't': 
				PostMessage(new BMessage(BUTTON_SET));
           		break; 
           		
           		case 's': 
				PostMessage(new BMessage(MENU_GAME_SET_DAY_RATE));
           		break; 
           		
           		case 'p': 
				PostMessage(new BMessage(MENU_GAME_PAUSE));
           		break; 
           		
           
 		      }//fin switch 

           switch ( key )
            { 
           		case B_F1_KEY: 
				PostMessage(new BMessage(MENU_DOC));
           		break; 
           
 		      }//fin switch 
 }