#include "PopWindow.h"
#include "MapView.h"

MapView::MapView(BRect r,Country **Country_id,Group **Group_id, Politic **Politic_id, day *compteur) :
	BView(r, "", B_FOLLOW_ALL | B_WILL_DRAW| B_PULSE_NEEDED, B_WILL_DRAW | B_ASYNCHRONOUS_CONTROLS)
{
		
////////////////////////////////////////////////////////////////////////////

	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id; 
		
////////////////////////////////////////////////////////////////////////////

	dragging=false;
	dragging_view=false;
	country_selected=false;
	initDone=false;
	
	
	pause_angle=0;
	buttons=0;

 	final_bitmap=frontier_bitmap=bump_bitmap=NULL;
 	gray_ptr=color_ptr=full_ptr = NULL;
 	gray_ptr_start=color_ptr_start=full_ptr_start = NULL;
	dragging=dragging_view=false;

	previous_ct=0; 
	result=0;
	agressor=victim=0;
	country_selected=false;


	fprintf(stderr,"\nMapView created.");
  
}


void MapView::AttachedToWindow()
{

	fprintf(stderr,"\nMapView AttachedToWindow...");

    SetViewColor(0,0,0);

	//création des images
	old_line_rect = Bounds(); //pour la première fois..
	bitmap_rect = BRect(0, 0, jour->map_x_size- 1, jour->map_y_size- 1); //meme taille pour les deux of course


	PreparePics();




	fprintf(stderr,"\nCalling  Init...");
	Init(); //recherche limites des pays sur la map 1160x740!


	fprintf(stderr,"\nCalling MultiplyAll...");

	////MISE A JOUR DE L'image finale via fonction MULTIPLY
	MultiplyAll();
	fprintf(stderr,"\nFirst MultiplyAll Done...");


 

 
	
	
}



void MapView::PreparePics()
{	
	fprintf(stderr,"\nMapView PreparePics...");

//	fprintf(stderr,"\nCreating final bitmap size: %d x %d",jour->map_x_size, jour->map_y_size);
//	final_bitmap = new BBitmap(bitmap_rect, B_RGB32);
//	fprintf(stderr,"\nCreated final bitmap OK");

   jour->app_dir(); //trouve le dir actuel de l'application (a ne pas appeler avant de créer la win)
   char name[255];
  
   sprintf(name,jour->dossier_app); //recupere le nom en string pour le modifier
   strcat(name,jour->dossier_scenario);        //on rajoute le dossier
   strcat(name,"maps/");
   
   //2 FOIS LE BUMP TEST
//   strcat(name,"bump.tif"); //et le nom du fichier
   strcat(name,"frontier.tif"); //et le nom du fichier
    
   //frontier_bitmap = jour->FetchBitmap(name,8); //supporte n'importe quel translator!!!
   

   BBitmap *t_bitmap = jour->FetchBitmap(name,32);  
   unsigned char *bts = (unsigned char*) t_bitmap->Bits();   
   
   frontier_bitmap = new BBitmap(bitmap_rect, B_CMAP8);
   unsigned char *dest =	 (unsigned char*) frontier_bitmap->Bits();   
   	
   uint32 pos=0;
   uint32 leng=frontier_bitmap->BitsLength();	
   while (pos!=leng)
         {
             *dest=*bts;
             dest++; pos++;
             bts++; bts++; bts++; bts++;
          }	


	fprintf(stderr,"\nMapView deleting frontier temp bitmap.");
 
   delete t_bitmap;	


/*
Hé, gran con!
LIS CA SI TU TE SOUVIENS PAS COMMENT CA MARCHAIT!
DONC ä LA BASE LES PICS DOIVENT ÈTRE EN 8 BITS MAIS COMME LES TRANSLATORS
CONVERTISSENT AUTOMATIQUEMENT EN 32 ON EST OBLIGE DE RECONVERTIR
ET POUR RETROUVER LES MEMES VALEURS AUX MEMES EMPLACEMENTS ON EST OBLIGES 
D'avoiR DES PICS EN NIVEAUX DE GRIS. VU QUE FORCEMENT LE GRIS EN RGB CA CHANGE PAS
LA PALETTE DES PICS EN GRIS DOIT DONC AVOIR POUR
LA COULEUR 0.... R:0 G:0 B:0
LA COULEUR 2.... R:2 G:2 B:2
et ainsi de suite... on peut pas faire autrement. Parait que c'est comme ça
les B_CMAP8 sont avec la palette fixe du systeme point final. Les CMAP8 tels que je les utilise
peuvent pas etres affichés avec un bete DrawBitmap vu que la palette inclue dans le BBitmap
n'est pas la bonne.

-- Ben j'ai relu ça 4 ans plus tard en 2003, et je t'emmerde, gamin :-)
*/
 

   sprintf(name,jour->dossier_app); //recupere le nom en string pour le modifier

   strcat(name,jour->dossier_scenario);        //on rajoute le dossier
   strcat(name,"maps/");
//   strcat(name,"Water.jpg"); //et le nom du fichier
   strcat(name,"bump.tif"); //et le nom du fichier
   

   BBitmap *tmp_bitmap = jour->FetchBitmap(name,32); //supporte n'importe quel translator!!!
   bts = (unsigned char*) tmp_bitmap->Bits();   

   bump_bitmap = new BBitmap(bitmap_rect, B_CMAP8);
   dest =	 (unsigned char*) bump_bitmap->Bits();   
   	
 pos=0;
 leng=bump_bitmap->BitsLength();	
   while (pos!=leng)
         {
           *dest=*bts;
           dest++; pos++;
           bts++; bts++; bts++; bts++;
          }	




   delete tmp_bitmap;	
//-------------------------------------------------------------------------

//ORDRE ABVR
set_gray_palette();
//met du gris dans la fausse palette pic relief (bump)
//la vraie palette est celle (fixe) du système...


}




void	MapView::Init()
{

	fprintf(stderr,"\nMapView Init...");
	
	


fprintf(stderr,"\nCalculating table multiply...");


//CALCUL TABLE MULTIPLY
int32 a,b;

//value=frontier_palette[(*color_ptr *3)+composante];
// *full_ptr = (*gray_ptr * value) / 255;

for (a=0; a!=256; a++)
	  {
		for (b=0; b!=256; b++)
	  	{
			tab_multiply[a][b]= (a * b) / 256;
	  	}  
	  }   		       	

	  
//------------------------------------------------------------------------------------------------

	fprintf(stderr,"\nTable multiply done");


unsigned char the_ctry,val; //pour pointer dans list pays
BPoint le_point;
Country *ct;
le_point.Set(0,0);
char str[255];	


BTextView *tmp; //pointeur sur le texte du main_alert win
tmp=jour->main_alert->TextView();


agressor=0;
victim=0;

//Pour que cette routine marche il faut qu'il y ait ça dans le constructeur country:
//limit.top=jour->map_y_size-1;
//limit.left=jour->map_x_size-1;
//limit.bottom=0;
//limit.right=0;

//------------------------------------------------------------------------------------------------




	int step=0;	
	while(le_point.y != jour->map_y_size-1) //pas PIC_SIZE-1 sinon il fait pas le dernier
		{
			step--;
			if (step<=0)
			{
				step=10;
				sprintf(str,"Finding bounds on line #%g",le_point.y);
				jour->main_alert->Lock();
				tmp->SetText(str);
				jour->main_alert->Unlock();
			}
					while(le_point.x!=jour->map_x_size-1) //chaque pixel
					{	
						val=SelectCountry(le_point); //une fois par point
						
						the_ctry=jour->country_first;
						while(the_ctry!=jour->country_last+1) //chaque pixel chaque pays
						    {
							
							ct=Ct_pointer[the_ctry]; //histoire de faire des lignes courtes
														
							if (val==the_ctry) //si on est dans le bon pays
								{						    
						    
						    	if (le_point.x < ct->limit.left)  ct->limit.left = le_point.x;
								if (le_point.y < ct->limit.top) 	  ct->limit.top = le_point.y;
							
								if (le_point.x > ct->limit.right)		ct->limit.right  = le_point.x;
								if (le_point.y > ct->limit.bottom)		ct->limit.bottom = le_point.y;
								}
								the_ctry++; 
					    	}//fin while ctry
					
					    le_point.x++; //avance dans l'horizontal
					}

		le_point.x=0; //on se remet au début de la ligne		
		le_point.y++; //et on passe à la suivante
		}


//--fin recherche rectangle

	fprintf(stderr,"\nFinding center...");

//on trouve le centre
the_ctry=jour->country_first;
while(the_ctry!=jour->country_last+1) //tous les rectangles aux valeurs extremes inverses
{
	ct=Ct_pointer[the_ctry]; //histoire de faire des lignes courtes
				
	ct->center_x = (ct->limit.left + ct->limit.right)  /2 ;
	ct->center_y = (ct->limit.top  + ct->limit.bottom) /2 ;

	the_ctry++;
}



	fprintf(stderr,"\nMapView INIT DONE.");

    
    initDone=true;
}




//------------------------------------------------------------

MapView::~MapView()
{
//will cause crash on exit... 
	delete	frontier_bitmap;
	delete	bump_bitmap;
	delete	final_bitmap;
}

//------------------------------------------------------------

void MapView::Draw(BRect update_rect)
{

	if(!initDone)
		return;

//	fprintf(stderr,"\nMapView DRAW CALLED.");

//FLOOR ESSENTIEL SINON COORDONNES DELIRENT!!!
BRect full_update=update_rect;
full_update.left 	=	floor(full_update.left 		/ jour->zoom_level);
full_update.right	=	floor(full_update.right		/ jour->zoom_level);
full_update.top 	=	floor(full_update.top 		/ jour->zoom_level);
full_update.bottom 	=	floor(full_update.bottom	/ jour->zoom_level);

		//fprintf(stderr,"\nDRAWING DISABLED");

//	//CLear blue
//	SetHighColor(0,50,100); //couleur du texte
//	FillRect(this->Bounds(),B_SOLID_HIGH); //B_SOLID_HIGH pour du plein pattern


if (final_bitmap!=NULL)
	DrawBitmap(final_bitmap, update_rect, update_rect);
	else
	{ 
		SetHighColor(0,0,100); //couleur du texte
		FillRect(update_rect);
	}
    
	//show select
	if (jour!=NULL)
	{
  		SetPenSize(1);
		SetHighColor(255,255,0); //couleur du texte
		jour->rect_update_select=Ct_pointer[jour->active_country]->limit; //stocke valeur pour prochain effacement
		StrokeRect(jour->rect_update_select,B_SOLID_HIGH); //dessin
	}

	ShowTroops();
//	ShowSelect();
	
	
}

//-----------------------------------------------------------------

void MapView::set_frontier_palette(unsigned char which_color,
                      unsigned char rval, unsigned char gval,unsigned char bval)
{ 
//	fprintf(stderr,"\nMapView set frontier_palette");

  int position;
  position=(which_color*3)+1; //+1 b-coz alpha
  frontier_palette[position] = bval;
  frontier_palette[position+1] = gval;
  frontier_palette[position+2]   = rval;
  
}

//-----------------------------------------------------------------

void MapView::set_gray_palette()
{ //met la palette a un bete degrades de gris

	fprintf(stderr,"\nMapView set gray_palette");

  unsigned char gray_val=0;
  int pos_pal=0;
  while (pos_pal != 768-3)
  {  bump_palette[pos_pal]   = gray_val;    //set_R
     bump_palette[pos_pal+1] = gray_val;  //set_G
     bump_palette[pos_pal+2] = gray_val;  //set_B
     gray_val++;
     pos_pal+=3;
  }
 
  
}//fin set_pal_gray

void MapView::update_map_palette()
{

//	fprintf(stderr,"\nMapView update map_palette");

set_frontier_palette(COL_SEA,20,40,120); 
set_frontier_palette(COL_BORDER,0,0,0); 

unsigned char tmp = jour->country_first; 
unsigned char grp;
rgb_color couleur;

while (tmp!=jour->country_last+1)
{
	grp=Ct_pointer[tmp]->group; //trouve le groupe à qui appartient le pays
	couleur=Grp_pointer[grp]->grp_color;  //trouver la couleur du groupe auquel appartient le country
	set_frontier_palette(tmp,couleur.red,couleur.green,	couleur.blue); //et l'applique au pays
tmp++;	
}
}//finupdate map_palette


//---------------------------------------------

void MapView::CountriesChosen()
{

//	fprintf(stderr,"\nMapView CountriesChosen");

agressor=SelectCountry(start); 
victim=SelectCountry(end);

if  (agressor!=victim && agressor!=COL_SEA && agressor!=COL_BORDER
     && victim!=COL_SEA && victim!=COL_BORDER) 
   //SI ON A TIRE UNE LIGNE d'un pays à un autre
	{
		//RETRAITE
		//si celui d'ou tu pars ("agressor") n'est pas a toi
		//et celui ou tu arrives ("victim") l'est, c'est une retraite
		if (Grp_pointer[Ct_pointer[agressor]->group]->player==COMPUTER
			&& Grp_pointer[Ct_pointer[victim]->group]->player!=COMPUTER
			&& Ct_pointer[agressor]->war==ON //sinon on peut faire retraite 
											 //pendant le trajet et ça merde
											 //attention, agressor c'est juste celui d'où`on part
			)							
		{
		
		  char str[255];
		  sprintf (str,"Do you really wish to retreat to ");
		  strcat (str,Ct_pointer[victim]->name);
		  strcat (str,"?\nYou'll lose about 10% of your troops in this operation.");
		  BAlert *alert = new BAlert("", str, "No", "Yes!"); 
		   int32 button_index;
   
  		 switch(button_index = alert->Go())
  		 {
  		 //les boutons ont toujours les valeurs 0,1,2 (trois boutons max)
 		case 1:
   		//en fait la victim c'est l'agressor... mais c'est une sorte de victime puisqu'il fuit!
   		Ct_pointer[agressor]->Retreat(Ct_pointer[victim]);
   		break;
   		
		}//fin switch
			
		result = 0; //on va pas plus loin ensuite	
		}
		else 
		{
        
        if (Grp_pointer[Ct_pointer[agressor]->group]->player!=COMPUTER)
        
		{
		result=0;

		//y a-t-il quatre attaquants déja?
		if (Ct_pointer[victim]->agressor_01!=NULL) result++;
		if (Ct_pointer[victim]->agressor_02!=NULL) result++;
		if (Ct_pointer[victim]->agressor_03!=NULL) result++;
		if (Ct_pointer[victim]->agressor_04!=NULL) result++;
	
		//si c'est le meme attaquant c'est bon, il continue
		if (Ct_pointer[agressor]==Ct_pointer[victim]->agressor_01) result--; 
		if (Ct_pointer[agressor]==Ct_pointer[victim]->agressor_02) result--; //si c'est le meme attaquant c'est bon, il continue
		if (Ct_pointer[agressor]==Ct_pointer[victim]->agressor_03) result--; //si c'est le meme attaquant c'est bon, il continue
		if (Ct_pointer[agressor]==Ct_pointer[victim]->agressor_04) result--; //si c'est le meme attaquant c'est bon, il continue
		
		if (Ct_pointer[agressor]->group==Ct_pointer[victim]->group) result=0; //si renforts
		
		if (result>=4) //si plus de 3 attaquants
			{ BAlert *alert = new BAlert("","Country already suffers from four different attacks","Shame");
			 alert->Go();
			jour->active_country=SelectCountry(start);
			jour->active_group=Ct_pointer[jour->active_country]->group;
	
			ShowSelect();
			agressor=victim; //pour skipper le menu envoi des troupes
			}
		
		if (result<4) //si moins de 3 attaquants
		{
		
		
		
/////////////////////////////////////////////////
//TEST SI PAYS DEJA EN GUERRE
/////////////////////////////////			
  unsigned char a,b,c,d;

		a=Ct_pointer[victim]->attacked_by;
		b=Ct_pointer[agressor]->group;
		
		c=Ct_pointer[victim]->group;
		d=Ct_pointer[agressor]->group;

if (Ct_pointer[agressor]->victim_04==NULL) //seulement si pas déjà 4 attaques
{
		
		if (Ct_pointer[victim]->war==ON && a!= b && c!= d)
		
    	{
		  BAlert *alert = new BAlert("", 
                     "Country already under attack by another party! Your troops won't be able to attack unless the other have finished fighting...", 
                     "Go on !", "Sorry..."); 
   int32 button_index;
   
   switch(button_index = alert->Go())
   {
   //les boutons ont toujours les valeurs 0,1,2 (trois boutons max)
   case 0: //on attaque quand même


		sendWindow = new SendWindow(Ct_pointer[agressor],Ct_pointer[victim],jour);
	    sendWindow ->Lock();		
	    sendWindow ->Show();	
	    sendWindow ->Unlock();	

		jour->active_country=victim;
		jour->active_group=Ct_pointer[jour->active_country]->group;
	
		ShowSelect();
		
   break;
   	
   
    //on n'attaque pas...
   //   case 1: break;
   
    	}//fin switch alert
	}//fin if agresseur de guerre existante est un autre que le nouveau

		else{ //donc si le pays est pas déjà en guerre		
		

		sendWindow = new SendWindow(Ct_pointer[agressor],Ct_pointer[victim],jour);
		sendWindow->Lock();
	    sendWindow ->Show();		
		sendWindow ->Unlock();	

		jour->active_country=victim;
		jour->active_group=Ct_pointer[jour->active_country]->group;
	
		ShowSelect();
		}		
		
		
		}//fin if result<4

	}

}

}//fin else retraite
}//fin else not computer


 //si click seulement ou tire une ligne dans le meme pays

if  (agressor==victim && agressor!=COL_SEA && agressor!=COL_BORDER)
	{ jour->active_country=SelectCountry(start); 
	   jour->active_group=Ct_pointer[jour->active_country]->group;
	
		ShowSelect();
		}

}

void MapView::MouseUp(BPoint point)
{

//	fprintf(stderr,"\nMapView MouseUp");


if (jour->edit_mode==ON) //en cas d'edit mode
	{
	
	if (jour->paint_mode==ON)
	{
			if (buttons==B_PRIMARY_MOUSE_BUTTON)
			{
			unsigned char verif;
    		verif= SelectCountry(point);	
			if(verif!=COL_BORDER && verif!=COL_SEA && verif != COL_EMPTY)
				{
					Country *ctry=Ct_pointer[verif];
					ctry->base_group =	ctry->group = jour->active_group;
					Grp_pointer[jour->active_group]->active=ON; //pour pouvoir réactiver un groupe mort dans l'éditeur
					
					BMessage *msg = new BMessage(MULTIPLY_RECT);
					msg->AddRect("zone",ctry->limit);				
					jour->mainWin->PostMessage(msg);
					}
			}//fin gauche		
	
	 }//fin paintmode ON
		
	else //donc si paintmode est off on est en select mode. 
    	{
    	
    	if (buttons==B_PRIMARY_MOUSE_BUTTON)
			
			{
    	unsigned char verif;
    	verif= SelectCountry(point);
		if(verif!=COL_BORDER && verif!=COL_SEA && verif != COL_EMPTY)
			{
			jour->active_country = verif;
		    jour->active_group = Ct_pointer[jour->active_country]->group;
		    jour->active_politic = Grp_pointer[jour->active_group]->politic;
		    jour->editWin->PostMessage(SET_EDIT); 
			}

			}//fin primary
		}//fin paintmode OFF
	}//fin editmode

		else 
		{
			if (country_selected==true) CountriesChosen();
		}


country_selected = false; 

ShowSelect();
jour->infoWin->PostMessage(DRAW_INFO);

//-----------------	
	
	//quand c'est fini...
	dragging=false;
	dragging_view=false;
	country_selected=false;

	be_app->SetCursor(&simple_cross[0]); //pour si on était en dragging_view ==true
	
	ShowSelect();
}


void MapView::UpdateTitle()
{

	fprintf(stderr,"\nMapView UpdateTitle");

		char str[1024];
		if (jour->edit_mode==ON) sprintf(str,"W6 - Editing Scenario");
		else
			{
				sprintf(str,"W6 - playing with ");
				strcat(str, Grp_pointer[jour->player_group]->grp_name);
			}
		jour->mainWin->SetTitle(str);
}    
    
    
void MapView::MouseDown(BPoint point)
{

	//fprintf(stderr,"\nMapView MouseDown");


//le premier point est donné par le click
//le deuxième par la routine ci-dessous

start=point;  end=point;

agressor=0; // il FAUT une valeur par défaut ... la mer...
victim=0;

//on a besoin des buttons après... dans le mousemoved
GetMouse(&end,&buttons);

dragging=true; //n'importe quel bouton

if (buttons==B_SECONDARY_MOUSE_BUTTON) 
	{
		dragging_view=true;	
		be_app->SetCursor(B_HAND_CURSOR);//curseur par défaut

	}
else if (buttons==B_PRIMARY_MOUSE_BUTTON)
	{
		country_selected = true; 
		ShowSelect();
	}//fin primary

} //FIN fonction mousedown


void MapView::MouseMoved(BPoint point, uint32 transit, const BMessage *message)
{
//if (transit==B_ENTERED_VIEW)  be_app->SetCursor(&simple_cross[0]);
//if (transit==B_EXITED_VIEW)   be_app->SetCursor(B_HAND_CURSOR);//curseur par défaut

GetMouse(&end,&buttons); //faut le refaire sinon la ligne reste tirée

//si tu bouges pendant que tu laches tu reçois pas le mouseup... alors faut le renvoyer
//sinon la ligne reste tirée après que t'ai lâché
//GetMouse(&end,&buttons);
if (!buttons) if (dragging==true) return;


if (buttons==B_PRIMARY_MOUSE_BUTTON)
{
	ShowSelect();
	if (jour->edit_mode==OFF) //si on est en train de jouer, voir beaucoup plus pas pour edit mode
	{
		ShowTroops();
		ShowLineAndName();
	}//fin not edit mode

}//fin primary


//---------------------------------------------------------------------------------
// Changement du nom du pays dans la barre de titre...
//---------------------------------------------------------------------------------

uint8 t = SelectCountry(point);
bb_help.SetHelp(this, Ct_pointer[t]->name);

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------



//---------------------------------------------------------------------------------
//SI BOUTON DROIT (editeur ou game) DRAG DRAG DRAG DRAG DRAG
//---------------------------------------------------------------------------------

if (dragging_view==true)
{ 

			//ATTENTION si je fais
			//end = point, c'est pas comme le getmouse
			//apparement il y a un délai et çA fait tout merder (ca scrolle trop loin)
			//donc bien que dans un mousemoved on refait un getmouse pour les coord
       		GetMouse(&end, &buttons);
       		
			if (start != end)
      	 		{
      	 		delta=start-end;      	 	
      	 		
      	 		delta.x *= jour->zoom_level;
      	 		delta.y *= jour->zoom_level;
      	 		

				//Pour EVITER BLOP quand on essaie de scroller out of limits...
				//---------------------------------
				
				//si nég et barre tout en haut à gauche on scrolle pas...
				if (delta.x < 0 && (jour->scroll_hori->Value() ) == 0)  delta.x=0;
				if (delta.y < 0 && (jour->scroll_verti->Value()) == 0)  delta.y=0;

				//si pos
				if (delta.x > 0 && (jour->scroll_hori->Value() )   >= 
					jour->map_x_size- (v_rect.right )-B_V_SCROLL_BAR_WIDTH)  delta.x=0;
				
				if (delta.y > 0 && (jour->scroll_verti->Value() )  >= 
					jour->map_y_size-(v_rect.bottom ) -B_V_SCROLL_BAR_WIDTH) delta.y=0;



      	 		ScrollBy(delta.x,delta.y);
       			start=end;
				start.x += delta.x; //car quand on scrolle le BPoint change aussi!!!
				start.y += delta.y; //faut le redécaler d'autant
				//v_rect.PrintToStream();
				}

}//fin right button (secondary button).

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------

	
} //fin fonction MouseMoved

//--------------------------------


//MULTIPLY par zone
void MapView::Multiply(BRect la_zone)
{

	if(!initDone)
	{
		fprintf(stderr,"\nMULTIPLY Before initDone ABORTED!");
		return;
	}
	
//		fprintf(stderr,"\nMultiply called");

//	if (bump_bitmap==NULL || frontier_bitmap==NULL)
//		return;


//	fprintf(stderr,"\nMULTIPLY: start");

	//met les couleurs des pays sur la palette de la pic frontier
	update_map_palette();

//	fprintf(stderr,"\nMULTIPLY: map updated");

	//pointeurs sur les 3 pics
    long pos_bits;


	if (gray_ptr_start==NULL)
	{
	    //3 pointeurs sur les 3 pics
	   	gray_ptr_start	= (unsigned char *)bump_bitmap->Bits(); 
		fprintf(stderr,"\nMULTIPLY: bits from bump OK");
		color_ptr_start	= (unsigned char *)frontier_bitmap->Bits();
		fprintf(stderr,"\nMULTIPLY: bits from frontier OK");
		fprintf(stderr,"\nMULTIPLY: CREATING FINAL_BITMAP");
		final_bitmap = new BBitmap(bitmap_rect, B_RGB32);
	  	full_ptr_start	= (unsigned char *)final_bitmap->Bits(); 
		
		fprintf(stderr,"\nMULTIPLY: ALL Bits obtained!");
	}


	//avance jusqu'au pixel de départ
    pos_bits = (long int )((la_zone.left-1)+(jour->map_x_size*(la_zone.top-1))); //pixel de départ (haut gauche du rect)
	if (pos_bits < 0 ) pos_bits=0;
	color_ptr	= color_ptr_start + pos_bits;	//avance jusqu'au pixel en question
    gray_ptr	= gray_ptr_start +pos_bits;		//avance jusqu'au pixel en question
	full_ptr	= full_ptr_start +(pos_bits*4);	//RGB+A!!!

    unsigned char composante;
    int32 pos_x,pos_y,largeur,hauteur;   
    largeur =  (int32)la_zone.Width()+2;
    hauteur =  (int32)la_zone.Height()+2;

	//pour eviter tout problème
	if (largeur<1) largeur=1;
	if (hauteur<1) hauteur=1;
	if (largeur>=jour->map_x_size) largeur=jour->map_x_size;
	if (hauteur>=jour->map_y_size) hauteur=jour->map_y_size;

//	fprintf(stderr,"\nMULTIPLY: before loop");
   
	pos_y=0;
	while (pos_y !=  hauteur) //changement de ligne
	{   
  
 		 pos_x=0;
   		 while (pos_x !=  largeur) //Changement de pixel sur la ligne
           { 
           
			   composante=1;
        	   while (composante != 4)   //Changement de composante RGB  
        	   							//on avance de 1 pixel dans le gris et de 3 en couleur
         	  {
  	        	
  	        	//value=frontier_palette[(*color_ptr *3)+composante];
   		       	// *full_ptr = (*gray_ptr * value) / 255;
   		       
   		       //	*full_ptr=*gray_ptr;
   		       	
   		       	//LE CALCUL JUSTE C CA, lE reste cest des tests
   		       	*full_ptr = tab_multiply[*gray_ptr] [frontier_palette[(*color_ptr *3)+composante]];

  		    	full_ptr++;
        	    composante++;
           		}
        
                full_ptr++; //on saute l'alpha
        
		   		gray_ptr++;
    		    color_ptr++;
   			    pos_x++;      //pixel suivant
        }//fin while pos_x, fin de la ligne
  	
  	pos_y++;      //ligne suivante
	gray_ptr	+= jour->map_x_size-largeur;
	color_ptr	+= jour->map_x_size-largeur;
	full_ptr	+= (jour->map_x_size-largeur)*4;
	
  }//fin pos_y!=hauteur


//	fprintf(stderr,"\nMULTIPLY: draw");


	Draw(la_zone);

}//fin fonction Multiply()



//MULTIPLY TOUTE LA PIC
void MapView::MultiplyAll()
{
	
	
//	fprintf(stderr,"MULTIPLY ALL DISABLED!");
//	return ;
	
	if (jour!=NULL)
	if (jour->mainWin!=NULL)
	{
		BMessage *msg = new BMessage(MULTIPLY_RECT);
		msg->AddRect("zone", BRect(0,0,jour->map_x_size-1,jour->map_y_size-1));				
		jour->mainWin->PostMessage(msg);
	}

}
//--------------------------------------

unsigned char MapView::SelectCountry(BPoint pix)
{
	
	if (jour!=NULL)
	if (frontier_bitmap!=NULL)
	{

		pix.x = floor(pix.x/ jour->zoom_level);
		pix.y = floor(pix.y/jour->zoom_level);

		uint32 pos_bits;
		pos_bits=(uint32)(pix.x+(jour->map_x_size*pix.y));

		unsigned char	*bits = NULL;

		bits = (unsigned char *)frontier_bitmap->Bits(); //pour accèder aux pixels directement
		bits+=pos_bits;//avance jusqu'au pixel en question

		unsigned char val = *bits;
	 
		//Avoid invalid countries
		if (jour->active_country > jour->country_last || jour->active_country < jour->country_first)
			jour->active_country = jour->country_first; 


	
		if (val > jour->country_last || val < jour->country_first)
		  val=jour->active_country;

		return val;

	}	
	else
	{
		fprintf(stderr,"\nSelectCountry: no frontier_bitmap");
		 return COL_SEA;
	}
}



//----------------------------------------------------------------

//-------------------------------
	
void MapView::Pulse()
{ 
	if(!initDone)
		return;
		
//	fprintf(stderr,"\nMapview pulse");


//CE PULSE A PAS BESOIN D'ETRE PAUSE VU QUE il n'y a que dans Running quon modifie
//avec des daypassed, ici on update juste la pic... si nécessaire

if (jour->game_started==ON) //pour pas qu'on voie la pause s'afficher dans draw alors qu'on choisit son groupe au début
	{

	if (jour->pause==OFF)
		{
			jour->sq_size+=2;
			if (jour->sq_size > 8)  {jour->sq_size=4; 	 Draw(Bounds());	}
			ShowSelect(); //carré selection pour edit aussi
			if (jour->edit_mode==OFF)  
				{	
					ShowTroops();
					if (country_selected==true) ShowLineAndName();
				}
			}
	else //la pause donc
		{
	BPoint center = BPoint(jour->map_x_size/2, jour->map_y_size/2);
	BRect update_it = BRect(center,center);
	update_it.InsetBy(-216,-216);
	Draw(update_it);	//on efface
	SetDrawingMode(B_OP_MAX); 
	
	if (pause_angle >=359) pause_angle=0; else pause_angle++;
	BFont font; 
	SetFontSize(32);
	SetHighColor(255,255,255);
   	
	pause_angle++;
   	font.SetRotation(pause_angle); 
  	SetFont(&font, B_FONT_ROTATION); 
    DrawString("Game paused",center); 
	
 	SetDrawingMode(B_OP_COPY); //Restaure l'ancien
	
		
	}


} //fin if game started


}//fin fulse 



void MapView::ShowLineAndName()
{

pattern stripes = { 0xc7, 0x8f, 0x1f, 0x3e, 0x7c, 0xf8, 0xf1, 0xe3 };
unsigned char ct1,ct2;

char txt[255],txt2[255];
unsigned int distance=0;
#define SCROLL_SPEED 8	
 
	SetFont(be_bold_font);
	SetFontSize(12/jour->zoom_level);
    SetPenSize(4/jour->zoom_level);
    SetHighColor(255,255,0); //couleur du texte


			//Ca prend les valeurs de start et end...
       		ct1=SelectCountry(start);	
       		ct2=SelectCountry(end);
       		distance=Ct_pointer[ct1]->FindDistance(Ct_pointer[ct1],Ct_pointer[ct2]);			
    	   		
    	    DrawString(Ct_pointer[ct1]->name,BPoint(floor(start.x/ jour->zoom_level),floor(start.y/ jour->zoom_level)));  //affiche le nom attaquant
			sprintf(txt,Ct_pointer[ct2]->name);
            
            if(ct1!=COL_BORDER && ct2!=COL_BORDER &&
               ct1!=COL_SEA && ct2!=COL_SEA)
            {
	            sprintf(txt2,", %u km",distance);
   		         strcat(txt,txt2);
            }
            DrawString(txt,BPoint(floor(end.x/ jour->zoom_level),floor(end.y/ jour->zoom_level)));		//affiche nom victime
    
            SetDrawingMode(B_OP_INVERT); 
            
			StrokeLine(BPoint(floor(start.x/ jour->zoom_level),floor(start.y/ jour->zoom_level)),
					   BPoint(floor(end.x/ jour->zoom_level),floor(end.y/ jour->zoom_level)),stripes);
			//StrokeLine(start,end,stripes);
			SetDrawingMode(B_OP_COPY); //restaure le mode normal pour restaurer l'image


			//on stocke le rectangle pour effacement ultérieur
			if (start.x > end.x) 
				 { old_line_rect.right = start.x;   old_line_rect.left = end.x; }
			else { old_line_rect.right = end.x;   old_line_rect.left = start.x; }

			if (start.y > end.y) 
				 { old_line_rect.bottom = start.y;   old_line_rect.top = end.y; }
			else { old_line_rect.bottom = end.y;   old_line_rect.top = start.y; }

			old_line_rect.right +=200; //un peu de marge à cause du texte
			old_line_rect.InsetBy(-32,-32); //hauteur du texte aussi..
			
			
			//on agrandit update rect total si nécessaire 
			if (old_line_rect.right > jour->rect_update_select.right)		jour->rect_update_select.right = old_line_rect.right;
			if (old_line_rect.bottom > jour->rect_update_select.bottom)	jour->rect_update_select.bottom = old_line_rect.bottom;
			if (old_line_rect.left < jour->rect_update_select.left)		jour->rect_update_select.left = old_line_rect.left;
			if (old_line_rect.top < jour->rect_update_select.top)		jour->rect_update_select.top = old_line_rect.top;
			
	  
}



void MapView::ShowSelect()
{

	Draw(jour->rect_update_select); //efface l'ancien rectangle

//  	SetPenSize(1);
//	SetHighColor(255,255,0); //couleur du texte
//	jour->rect_update_select=Ct_pointer[jour->active_country]->limit; //stocke valeur pour prochain effacement
//	StrokeRect(jour->rect_update_select,B_SOLID_HIGH); //dessin

}


void MapView::ShowTroops()
{
pattern stripes = { 0xc7, 0x8f, 0x1f, 0x3e, 0x7c, 0xf8, 0xf1, 0xe3 };

unsigned char tmp_ct=jour->country_first; //unsigned char tmp_ct=jour->country_first
while (tmp_ct!=jour->country_last+1)
{

BRect rect1;
Country *ctry=Ct_pointer[tmp_ct]; 
SetPenSize(1);
//rect en haut à droite
rect1.Set(ctry->center_x-(jour->sq_size/2),ctry->center_y-(jour->sq_size/2),
		 ctry->center_x+(jour->sq_size/2),ctry->center_y+(jour->sq_size/2));

//on ne voit que le premier agresseur		 
if (ctry->agressor_01!=NULL)
{
SetHighColor(Grp_pointer[ctry->agressor_01->group]->grp_color);
FillRect(rect1,B_SOLID_HIGH); //B_SOLID_HIGH pour du plein pattern
SetHighColor(0,0,0);
StrokeRect(rect1,B_SOLID_HIGH); 
}




//-----------------------------------------------------------------------

SetPenSize(2);
SetDrawingMode(B_OP_OVER);
               
if (ctry->move_01!=OFF && ctry->victim_01!=NULL)
{
SetHighColor(Grp_pointer[ctry->group]->grp_color);
StrokeLine(BPoint(ctry->center_x,ctry->center_y),
		   BPoint(ctry->victim_01->center_x,ctry->victim_01->center_y),
		   stripes);
}

if (ctry->move_02!=OFF && ctry->victim_02!=NULL)
{
SetHighColor(Grp_pointer[ctry->group]->grp_color);
StrokeLine(BPoint(ctry->center_x,ctry->center_y),
		   BPoint(ctry->victim_02->center_x,ctry->victim_02->center_y),
		   stripes);
}

if (ctry->move_03!=OFF && ctry->victim_03!=NULL)
{
SetHighColor(Grp_pointer[ctry->group]->grp_color);
StrokeLine(BPoint(ctry->center_x,ctry->center_y),
		   BPoint(ctry->victim_03->center_x,ctry->victim_03->center_y),
		   stripes);
}

if (ctry->move_04!=OFF && ctry->victim_04!=NULL)
{
SetHighColor(Grp_pointer[ctry->group]->grp_color);
StrokeLine(BPoint(ctry->center_x,ctry->center_y),
		   BPoint(ctry->victim_04->center_x,ctry->victim_04->center_y),
		   stripes);
}



//-----------
tmp_ct++;



}//fin while 
SetDrawingMode(B_OP_COPY);        
}//fin fonction ShowTroops

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//----------------------------------------------------------------------


	
	
	
	
	