#include "PopWindow.h"
#include "EditorView.h"
#include <Button.h>

#define BUTTON_AGREE 'agre'
#define BUTTON_CANCEL 'canc'	

#define TAX_CHANGED 'taxc'

#define BUTTON_BUY_OK 'buya' //ATENTION !=BUTTON_BUY
#define BT_BUY_CANCEL 'buyc'	
#define FIELD_UPDATE  'upda'	

#define SET_PLUS_MSG  'setp'	
#define SET_MINUS_MSG 'setm'	

#define GROUP_COLOR_CHANGED    'grpc'

#define TEMP_CHANGED    'tmpc'	
#define WEATHER_CHANGED 'wthc'	

#define SPEED_CHANGED 'spdc'	

//J'ai remplacé tous les "" par des "0"
//pour éviter d'avoir des cases vides...
//dans certains cas c'était le nom de l'objet mais on s'en tape

//SendWindow==pOUR L'attaque sendtroops
SendWindow::SendWindow(Country *ct1,Country *ct2,day *compteur)
				: BWindow(compteur->find_win_pos(256,224), "                             ", B_FLOATING_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE)
{
BView *la_vue_du_fond = new BView(Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
la_vue_du_fond->SetViewColor(216,216,216);
AddChild(la_vue_du_fond);

Ctry_a=ct1;
Ctry_b=ct2;
	

BRect rect;	  //variable de rectangle utilisée pour les diverses créations d'objets

		//Bouton SEND
		rect.Set( 176-2, 96-2+64+32, 176+80-2, 96+32-2+64+32 );
		button_A = new BButton( rect,"BTA",	"Send", new BMessage( BUTTON_AGREE ) );          								 				 									 	

		//Bouton CANCEL
		rect.Set( 0+2, 96-2+64+32, 0+80+2, 96+32-2+64+32 );
		button_B = new BButton( rect,"BTB",	"Cancel", new BMessage( BUTTON_CANCEL ) );          								 				 									 	
	
	    
	
	SetDefaultButton(button_A);
	la_vue_du_fond->AddChild(button_A); //ajoute le bouton à la window
	la_vue_du_fond->AddChild(button_B); //ajoute le bouton à la window
	
//------------------------------------------------------------
//------------------------------------------------------------

	const char *tmp;
	char str[100];
	char str2[100];

	rect.Set( 0, 0, 256, 18);
	x_view = new BStringView(rect, "Title", Ctry_a->name);
	x_view->SetFont(be_bold_font);
	x_view->SetFontSize(12);
	x_view->SetHighColor(0,0,64);
	x_view->SetAlignment(B_ALIGN_CENTER);	

	rect.Set( 0, 18, 256, 18+18);
	y_view = new BStringView(rect, "Titleb", "yy");
	y_view->SetFont(be_plain_font);
	y_view->SetFontSize(12);
	y_view->SetHighColor(0,0,0);
	y_view->SetAlignment(B_ALIGN_CENTER);	
	sprintf(str,"Send troops to ");
	sprintf(str2,Ctry_b->name);
	tmp=strcat(str,str2); //on joint les deux bouts après car types différents
	y_view->SetText(tmp);
	
	la_vue_du_fond->AddChild(x_view);
	la_vue_du_fond->AddChild(y_view);
	
	//ATTENTION FAUT METTRE DES ZEROS PAS DU VIDE!!!
	//SINON LE ATOI DE LA LECTURE=CATASTROPHE AND CRASH
	rect.Set( 4, 64-22+6, 4+120, 64+6);
	infantry_control = new BTextControl(rect, "0", "Infantry", "1000", NULL);
	rect.OffsetBy(0,22);
	tank_control = new BTextControl(rect, "0", "Tanks", "0", NULL);
	rect.OffsetBy(0,22);
	marine_control = new BTextControl(rect, "0", "Marine", "0", NULL);
	rect.OffsetBy(0,22);
	airforce_control = new BTextControl(rect, "0", "Airforce", "0", NULL);
	rect.OffsetBy(0,22);
	missile_control = new BTextControl(rect, "0", "Missile", "0", NULL);
	rect.OffsetBy(0,22);
	nuke_control = new BTextControl(rect, "0", "Nukes", "0", NULL);


//----------------------------------------------------------

	rect.OffsetBy(128,(-5*22)-3);

	sprintf(str,"%ld",Ctry_a->infantry);
	a_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	sprintf(str,"%d",Ctry_a->tank);
	b_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	sprintf(str,"%i",Ctry_a->marine);
	c_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	sprintf(str,"%i",Ctry_a->airforce);
	d_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	sprintf(str,"%i",Ctry_a->missile);
	e_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	sprintf(str,"%i",Ctry_a->nuke);
	f_view = new BStringView(rect, "0", str );	


	//Bouton ADD 10%
	rect.Set( 94,192,94+32, 192+16);
	BButton* button_x = new BButton( rect,"0",	" + ", new BMessage( SET_PLUS_MSG ) );
	la_vue_du_fond->AddChild(button_x);	

	//Bouton SUB 10%
	rect.Set( 94+32,192,94+32+32, 192+16);
	BButton* button_y = new BButton( rect,"0",	" - ", new BMessage( SET_MINUS_MSG ) );
	la_vue_du_fond->AddChild(button_y);	
		
	la_vue_du_fond->AddChild(infantry_control);
	la_vue_du_fond->AddChild(tank_control);
	la_vue_du_fond->AddChild(marine_control);
	la_vue_du_fond->AddChild(airforce_control);
	la_vue_du_fond->AddChild(missile_control);
	la_vue_du_fond->AddChild(nuke_control);
	
	la_vue_du_fond->AddChild(a_view);
	la_vue_du_fond->AddChild(b_view);
	la_vue_du_fond->AddChild(c_view);
	la_vue_du_fond->AddChild(d_view);
	la_vue_du_fond->AddChild(e_view);
	la_vue_du_fond->AddChild(f_view);
	
	if (Ctry_a->access_nuke==OFF)	{	nuke_control->SetEnabled(false);	}
	else {	nuke_control->SetEnabled(true);	}

	if (Ctry_a->access_sea==OFF)	{	marine_control->SetEnabled(false);	}
	else {	marine_control->SetEnabled(true);	}
	
}

//----------------------------------------------------------------------------

//POUR LA GESTION DES MESSAGES ARRIVANT	
void SendWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what ){

   		case BUTTON_AGREE:
   	
		//attention, très important de checker ça!!
		if(button_A->IsEnabled()==true)
		 	{
		unsigned long inf,tnk,mar,air,mis,nuke;
   		inf= atoi(infantry_control->Text());
   		tnk= atoi(tank_control->Text());
   		mar= atoi(marine_control->Text());
   		air= atoi(airforce_control->Text());
   		mis= atoi(missile_control->Text());
   		nuke= atoi(nuke_control->Text());
        Ctry_a->send_troops(Ctry_b,inf,tnk,mar,air,mis,nuke);
		Lock();
		Close();
		  
		}
		break;
///////////////////////////////////////////////////////////////

   		case SET_PLUS_MSG:
   		char str[100];
   		sprintf(str,"%lu",Ctry_a->infantry-1000);
   		infantry_control->SetText(str);
   		sprintf(str,"%u",Ctry_a->tank);
   		tank_control->SetText(str);
   		sprintf(str,"%u",Ctry_a->airforce);
   		airforce_control->SetText(str);
		
		if (Ctry_b->access_sea==ON)
		{	//si l'ennemi est au milieu du continent faudrait éviter ;-)
   			sprintf(str,"%u",Ctry_a->marine);
	   		marine_control->SetText(str);
   		}
   		sprintf(str,"%u",Ctry_a->missile);
   		missile_control->SetText(str);
   		//faudrait pas attacker avec des nukes a moins de le vouloir vraiment
   		//sprintf(str,"%i",Ctry_a->nuke);
   		//nuke_control->SetText(str);
   		break;


   		case SET_MINUS_MSG:
   		sprintf(str,"%i",1000);
   		infantry_control->SetText(str);
   		sprintf(str,"%i",0);
   		tank_control->SetText(str);
   		sprintf(str,"%i",0);
   		airforce_control->SetText(str);
   		sprintf(str,"%i",0);
   		missile_control->SetText(str);
   		sprintf(str,"%i",0);
   		nuke_control->SetText(str);
   		break;
		
		case BUTTON_CANCEL:
		Lock();
		Close();
		break;
		
   	default:
   			// Call inherited if we didn't handle the message
   			BWindow::MessageReceived(message);

   			break;
   	
	}//fin switch;
}

BuyWindow::BuyWindow(Country *ct1,day *compteur)
				: BWindow(compteur->find_win_pos(256,256), "                             ",  B_FLOATING_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE)
{
BView *la_vue_du_fond = new BView(Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
la_vue_du_fond->SetViewColor(216,216,216);
AddChild(la_vue_du_fond);


Ctry_a=ct1;


BRect rect;	  //variable de rectangle utilisée pour les diverses créations d'objets

		//Bouton BUY
		rect.Set( 176-2, 96-2+64+32+32, 176+80-2, 96+32-2+64+32 +32);
		BMessage *button_A_msg = new BMessage( BUTTON_BUY_OK );
		button_A_msg->AddString("text", "BUY");
		button_A = new BButton( rect,"BTA",	"BUY", button_A_msg );          								 				 									 	

		//Bouton CANCEL
		rect.Set( 0+2, 96-2+64+32+32, 0+80+2, 96+32-2+64+32+32 );
		BMessage *button_B_msg = new BMessage( BT_BUY_CANCEL );
		button_B_msg->AddString("text", "BCC");
		button_B = new BButton( rect,"BTB",	"Cancel", button_B_msg );          								 				 									 	

	
	SetDefaultButton(button_A);
	la_vue_du_fond->AddChild(button_A); //ajoute le bouton à la window
	la_vue_du_fond->AddChild(button_B); //ajoute le bouton à la window
	
//------------------------------------------------------------
//------------------------------------------------------------

	char str[100];


	rect.Set( 0, 0, 256, 18);
	x_view = new BStringView(rect, "Title", Ctry_a->name);
	x_view->SetFont(be_bold_font);
	x_view->SetFontSize(12);
	x_view->SetHighColor(0,0,64);
	x_view->SetAlignment(B_ALIGN_CENTER);	

	rect.Set( 0, 18, 256, 18+18);
	y_view = new BStringView(rect, "Titleb", "Buy troops");
	y_view->SetFont(be_plain_font);
	y_view->SetFontSize(12);
	y_view->SetHighColor(0,0,0);
	y_view->SetAlignment(B_ALIGN_CENTER);	
	
	la_vue_du_fond->AddChild(x_view);
	la_vue_du_fond->AddChild(y_view);
	
	//ATTENTION FAUT METTRE DES ZEROS PAS DU VIDE!!!
	//SINON LE ATOI DE LA LECTURE=CATASTROPHE AND CRASH	
	rect.Set( 4, 64-22+6, 4+120, 64+6);
	infantry_control = new BTextControl(rect, "0", "Infantry", "100", new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	tank_control = new BTextControl(rect, "0", "Tanks", "0",new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	marine_control = new BTextControl(rect, "0", "Marine", "0",new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	airforce_control = new BTextControl(rect, "0", "Airforce", "0",new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	missile_control = new BTextControl(rect, "0", "Missile", "0", new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	nuke_control = new BTextControl(rect, "0", "Nukes", "0",new BMessage(FIELD_UPDATE) );
	rect.OffsetBy(0,22);
	dca_control = new BTextControl(rect, "0", "dca", "0", new BMessage(FIELD_UPDATE) );
	
	if (Ctry_a->access_sea==OFF) marine_control->SetEnabled(false);
//----------------------------------------------------------

	rect.OffsetBy(128,(-5*22)-3-22);


 	a_view = new BStringView(rect, "0", str );	
	
	rect.OffsetBy(0,22);
	b_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	c_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	d_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	e_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	f_view = new BStringView(rect, "0", str );	

	rect.OffsetBy(0,22);
	g_view = new BStringView(rect, "0", str );	

	la_vue_du_fond->AddChild(infantry_control);
	la_vue_du_fond->AddChild(tank_control);
	la_vue_du_fond->AddChild(marine_control);
	la_vue_du_fond->AddChild(airforce_control);
	la_vue_du_fond->AddChild(missile_control);
	la_vue_du_fond->AddChild(nuke_control);
	la_vue_du_fond->AddChild(dca_control);
	
	la_vue_du_fond->AddChild(a_view);
	la_vue_du_fond->AddChild(b_view);
	la_vue_du_fond->AddChild(c_view);
	la_vue_du_fond->AddChild(d_view);
	la_vue_du_fond->AddChild(e_view);
	la_vue_du_fond->AddChild(f_view);
	la_vue_du_fond->AddChild(g_view);
	
	
	if (Ctry_a->access_nuke==OFF)	{	nuke_control->SetEnabled(false);	}
	else {	nuke_control->SetEnabled(true);	}

	if (Ctry_a->access_sea==OFF)	{	marine_control->SetEnabled(false);	}
	else {	marine_control->SetEnabled(true);	}
		
	UpdateFields();
	
}



//POUR LA GESTION DES MESSAGES ARRIVANT	
void BuyWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what ){

   		case BUTTON_BUY_OK:

  		UpdateFields(); //important sinon si le mec valide pas le champ, il passe
		
		if(button_A->IsEnabled()==true)
		{//Très important de checker parce-que si on fait	
		 //Updatefields avant, ça peut disabler (à raison)
		Ctry_a->buy(atoi(infantry_control->Text() ),
					atoi(tank_control->Text() ),
					atoi(marine_control->Text() ),
					atoi(airforce_control->Text() ),
					atoi(missile_control->Text() ),
					atoi(nuke_control->Text() ),
					atoi(dca_control->Text() )
					);
					
		Lock();
		Close();
	
		}
		break;
	
		case FIELD_UPDATE:
		UpdateFields();

		break;
	
		case BT_BUY_CANCEL:
		UpdateFields();
		Lock();
		Close();
		
			break;
		
		
   	default:
   			break;
   	
	}//fin switch;

}

void BuyWindow::UpdateFields()
{


	const char *tmp;
	char str[32];
	char str2[32];
	uint64 calca,calcb,calcc,calcd,calce,calcf,calcg, total;
	
	sprintf(str,"x %g = ",COST_INFANTRY); //seul à virgule 
	calca=atoi(infantry_control->Text() );
	calca = (uint64)(calca*(float)COST_INFANTRY);
	sprintf(str2,"%llu",calca);
	tmp=strcat(str,str2); 
	a_view->SetText(tmp);		

	sprintf(str,"x %d = ",COST_TANK);
	calcb=atoi(tank_control->Text() );
	calcb*=COST_TANK;
	sprintf(str2,"%llu",calcb);
	tmp=strcat(str,str2); 
	b_view->SetText(tmp);		

	sprintf(str,"x %d = ",COST_MARINE);
	calcc=atoi(marine_control->Text() );
	calcc*=COST_MARINE;
	sprintf(str2,"%llu",calcc);
	tmp=strcat(str,str2); 
	c_view->SetText(tmp);		

	sprintf(str,"x %d = ",COST_AIRFORCE);
	calcd=atoi(airforce_control->Text() );
	calcd*=COST_AIRFORCE;
	sprintf(str2,"%llu",calcd);
	tmp=strcat(str,str2); 
	d_view->SetText(tmp);		

	sprintf(str,"x %d = ",COST_MISSILE);
	calce=atoi(missile_control->Text() );
	calce*=COST_MISSILE;
	sprintf(str2,"%llu",calce); 
	tmp=strcat(str,str2); 
	e_view->SetText(tmp);		


	sprintf(str,"x %d = ",COST_NUKE);
	calcf=atoi(nuke_control->Text() );
	calcf*=COST_NUKE;
	sprintf(str2,"%llu",calcf);
	tmp=strcat(str,str2); 
	f_view->SetText(tmp);		

	sprintf(str,"x %d = ",COST_DCA);
	calcg=atoi(dca_control->Text() );
	calcg*=COST_DCA;
	sprintf(str2,"%llu",calcg);
	tmp=strcat(str,str2); 
	g_view->SetText(tmp);		

	total=calca+calcb+calcc+calcd+calce+calcf+calcg;
	sprintf(str2,"%llu",total);
	sprintf(str,"Total in mio. $: ");
	tmp=strcat(str,str2); 
	
	if ( (Ctry_a->money) <= total)	
	{	button_A->SetEnabled(false);
		y_view->SetHighColor(200,0,0);
		}
	else	
	{button_A->SetEnabled(true);
	y_view->SetHighColor(0,0,0); //normalement en noir
		}
	y_view->SetText(tmp);		

}



ColorWindow::ColorWindow(Group *grp_x, day *compteur)
				: BWindow(jour->find_win_pos(304,128), "Change active group's color", B_FLOATING_WINDOW, B_NOT_ZOOMABLE )
{

BView *la_vue_du_fond = new BView(Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
la_vue_du_fond->SetViewColor(216,216,216);
AddChild(la_vue_du_fond);

	

	jour=compteur;
	grp=grp_x;

	col_control = new BColorControl(BPoint(10,10), B_CELLS_32x8, 4, "cc", new BMessage(GROUP_COLOR_CHANGED), false); 
	la_vue_du_fond->AddChild(col_control);
	col_control->SetValue(grp->grp_color);	
	
}



OrderWindow::OrderWindow(Country *ct1,day *compteur)
				: BWindow(compteur->find_win_pos(256,256), "Set parameters                         ", B_FLOATING_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE)
{
BView *la_vue_du_fond = new BView(Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
la_vue_du_fond->SetViewColor(216,216,216);
AddChild(la_vue_du_fond);

BRect rect;
	
Ctry_a=ct1;

rect.Set( 0, 4, 256, 4+18);

	x_view = new BStringView(rect, "Title", Ctry_a->name);
	x_view->SetFont(be_bold_font);
	x_view->SetFontSize(12);
	x_view->SetHighColor(0,0,64);
	x_view->SetAlignment(B_ALIGN_CENTER);	
	la_vue_du_fond->AddChild(x_view);


rect.Set(4,24+24,256-4,24+24+10); 
      slider_temp = new BSlider(rect, "0", "Expected temperature", 
      new BMessage(TEMP_CHANGED), 1, 5);
rect.OffsetBy(0,64); 
      slider_weather = new BSlider(rect, "0", "Expected weather", 
      new BMessage(WEATHER_CHANGED),1, 5);

slider_temp->SetHashMarks(B_HASH_MARKS_BOTTOM); 
slider_temp->SetHashMarkCount(5);
slider_temp->SetLimitLabels("Cold", "Hot");

slider_weather->SetHashMarks(B_HASH_MARKS_BOTTOM); 
slider_weather->SetHashMarkCount(5);
slider_weather->SetLimitLabels("Dry", "Rainy");

rgb_color temp_col = {0,0,150,0};
slider_temp->SetBarColor(temp_col);

rgb_color wt_col = {200,0,0,0};
slider_weather->SetBarColor(wt_col);

slider_temp->SetValue(Ctry_a->expected_temperature);      
slider_weather->SetValue(Ctry_a->expected_weather);      

la_vue_du_fond->AddChild(slider_temp);
la_vue_du_fond->AddChild(slider_weather);

rect.OffsetBy(0,64); 
char str[32];
sprintf(str,"%g",Ctry_a->tax);
tax_control = new BTextControl(rect, "0", "Army tax %", str, new BMessage(TAX_CHANGED) );
tax_control->SetAlignment(B_ALIGN_LEFT,B_ALIGN_CENTER);
la_vue_du_fond->AddChild(tax_control);




}


void ColorWindow::MessageReceived(BMessage *message)
{


message->PrintToStream();

 	switch ( message->what ){

   		case GROUP_COLOR_CHANGED:
   		coul=	col_control->ValueAsColor();
		grp->grp_color=coul;
		
		jour->mainWin->PostMessage(new BMessage (MULTIPLY_ALL));
		break;
   	default:
   			break;
   	
	}//fin switch

}
//----------------------------------------------------------


//POUR LA GESTION DES MESSAGES ARRIVANT	
void OrderWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what ){

   		case BUTTON_BUY_OK:
		Lock();
		Close();
		
		break;

   		case TAX_CHANGED:
		Ctry_a->set_tax(atoi(tax_control->Text()) );
		break;

   		case TEMP_CHANGED:
		Ctry_a->expected_temperature=slider_temp->Value();
		break;

   		case WEATHER_CHANGED:
		Ctry_a->expected_weather=slider_weather->Value();
		break;

				

   	default:
   			break;
   	
	}//fin switch
}
//-----------------------------------------------------


SpeedWindow::SpeedWindow(day *compteur)
				: BWindow(jour->find_win_pos(264,118), "Set game speed                    ", B_FLOATING_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
BView *la_vue_du_fond = new BView(this->Bounds(),"",B_FOLLOW_ALL,B_WILL_DRAW);
AddChild(la_vue_du_fond);

la_vue_du_fond->SetViewColor(216,216,216);  

BRect rect;

jour=compteur;

rect.Set(4,4,256-4,4+24+10); 
      slider_speed = new BSlider(rect, "0", "How many seconds for a day?", 
      new BMessage(SPEED_CHANGED), 1,10); 

slider_speed->SetHashMarks(B_HASH_MARKS_BOTTOM); 
slider_speed->SetHashMarkCount(10);
slider_speed->SetLimitLabels("1", "10");
slider_speed->SetStyle(B_TRIANGLE_THUMB);

rect.OffsetBy(0,64); 
      slider_jump = new BSlider(rect, "0", "Speed up (reduces playability!)", 
      new BMessage(SPEED_CHANGED), 1,100); 

slider_jump->SetHashMarks(B_HASH_MARKS_BOTTOM); 
slider_jump->SetHashMarkCount(100);
slider_jump->SetLimitLabels("1", "100");
slider_jump->SetStyle(B_TRIANGLE_THUMB);

slider_speed->SetValue(jour->day_step);      
slider_jump->SetValue(jour->jump_days);      
la_vue_du_fond->AddChild(slider_speed);
la_vue_du_fond->AddChild(slider_jump);

slider_speed->SetViewColor(216,216,216); 
slider_speed->SetViewColor(216,216,216); 
}
	
//-----------------------------------------------------------------
void SpeedWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what ){

   		case SPEED_CHANGED:
		jour->day_step  = slider_speed->Value();
		jour->jump_days = slider_jump->Value()-1; //faut 0 pour 1 day par jour donc moins 1
		break;				 
   	
	}//fin switch
}


//---------------------------------------------------------------------------------



ChooseWindow::ChooseWindow(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP], day *compteur)
				: BWindow(jour->find_win_pos(584,300), "                             ", B_MODAL_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE )
{
Ct_pointer=Country_id;
Grp_pointer=Group_id;
jour=compteur;

ch_view = new ChooseView(Bounds(), B_FOLLOW_TOP |B_WILL_DRAW| B_NOT_RESIZABLE| B_NO_BORDER ,
						  Grp_pointer,jour);
AddChild(ch_view); //ajoute la vue du texte à la window


}	
//-----------------------------------------------------------------
void ChooseWindow::MessageReceived(BMessage *message)
{

	
	unsigned char found,tmp_ct; //unsigned char tmp_ct=jour->country_first

	// Print the message to see its contents
//	message->PrintToStream();

 	switch ( message->what ){

	case BUTTON_DONE:
		Grp_pointer[jour->active_group]->player=PLAYER_01;
		
		//trouve le premier pays du groupe en question et l'active
		found=OFF;
		tmp_ct=jour->country_first; //unsigned char tmp_ct=jour->country_first
		while (tmp_ct!=jour->country_last+1 && found==OFF)
		{
			if (Ct_pointer[tmp_ct]->group==jour->active_group) 
			{jour->active_country=tmp_ct;
			 found = ON;
			}
			tmp_ct++;
		}	
		jour->player_group =jour->active_group;
		jour->mainWin->PostMessage(new BMessage(REDRAW_ME));
		jour->game_started=ON;
		jour->pause=OFF;
		jour->mainWin->PostMessage(UPDATE_TITLE);

		Lock();
		Close();
		break;
//   	default:			break;
   	
	}//fin switch
}

