#ifndef POP_WINDOW_H
#define POP_WINDOW_H

#include "day.h"
#include "country.h"
#include "group.h"
#include "def_col.h" //POUR GRP_X
#include "EditorView.h"


#define BUTTON_BUY 'buyt'
#define BUTTON_SET 'btor'

class SendWindow : public BWindow 
{
public:
virtual void 	MessageReceived(BMessage *message);
		SendWindow(Country *ct1,Country *ct2,day *compteur);
		
		BStringView *x_view,*y_view,*a_view,*b_view,*c_view,*d_view,*e_view,*f_view;

		BTextControl *infantry_control, *tank_control, *marine_control;
		BTextControl *airforce_control, *missile_control,*nuke_control;//NO DCA 
		
		BButton	*button_A,*button_B;
			
		Country *Ctry_a,*Ctry_b;
};
/////////////////////////////////////////////////////////////


class BuyWindow : public BWindow 
{
public:
		BuyWindow(Country *ct1,day *compteur); 

virtual void 	MessageReceived(BMessage *message);
		
		BStringView *x_view,*y_view,*a_view,*b_view,*c_view,*d_view,*e_view,*f_view;
		BStringView *g_view;
		BTextControl *infantry_control, *tank_control, *marine_control;
		BTextControl *airforce_control, *dca_control, *missile_control,*nuke_control;

	void	UpdateFields(); //calcule prix
	
		Country *Ctry_a;
		BButton *button_A,*button_B;

};

class OrderWindow : public BWindow 
{
public:
		OrderWindow(Country *ct1,day *compteur); 



virtual void 	MessageReceived(BMessage *message);
		
		BStringView *x_view;
		BTextControl *tax_control;
		BSlider *slider_temp,*slider_weather;
		Country *Ctry_a;

		
};

//------------------------------------------------------

class SpeedWindow : public BWindow 
{
public:
		SpeedWindow(day *compteur); 

		day *jour;


virtual void 	MessageReceived(BMessage *message);
		
		BStringView *x_view,*y_view;
		BSlider *slider_speed;
		BSlider *slider_jump;

		
};

//--------------------------------------------------------

class ChooseWindow : public BWindow 
{
public:
		ChooseWindow(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],day *compteur); 

ChooseView	*ch_view;

virtual void 	MessageReceived(BMessage *message);
Country	**Ct_pointer;
Group	**Grp_pointer;
day 	*jour;

		
};

//------------------------------------------------------

class ColorWindow : public BWindow 
{
public:
		ColorWindow(Group *grp_x,day *compteur); 


rgb_color coul;
	
virtual void 	MessageReceived(BMessage *message);
		BColorControl *col_control;
		Group *grp;
		day *jour;

		};

#endif
