#include "day.h"
#include "def_col.h"
#include <stdio.h>
#include <TranslationUtils.h>

BubbleHelper bb_help; //en extern


day::day(int start_me) //CONSTRUCTEUR DAY
{

sprintf(history_text,"The day it all started...");

zoom_level =1;

days_per_month=31; //valeur pour janvier
curday=1;
month_name="January";
month_counter=1;
year_counter=0;
month_id=1;           //janvier
start_year=start_me;
year=start_year+year_counter;
is_flag_load=OFF;


//-----------------------------------------------------------------------------------------------

//Ceci n'a rien à voir avec le day mais bon je vais pas chier une classe exprès
//et me faire chier à passer les paramètres pour une ou deux valeur globales.

interligne = 16; //pour text
full_log= ON;

game_started = OFF;
step=0;
day_step=DEFAULT_DAY_STEP; //nb de pulse a sauter avant d'agir...

jump_days=0;

game_level=NORMAL;
pause=ON; //avant de commencer faut choisir le joueur
     
edit_mode=OFF; 
paint_mode=OFF;

map_x_size=DEF_PIC_X_SIZE;
map_y_size=DEF_PIC_Y_SIZE;  

rect_update_select.Set(0,0,map_x_size-1, map_y_size-1);


	sq_size=6; //taille du carré clignotant
	
	country_first = DEF_FIRST_COUNTRY;
	country_last  = DEF_LAST_COUNTRY;
	
	group_first   = DEF_FIRST_GROUP;
	group_last    = DEF_LAST_GROUP;
	
	politic_first   = DEF_FIRST_POLITIC;
	politic_last    = DEF_LAST_POLITIC;
	
	
active_country = country_first;  
active_group = GRP_G; //pour edit_mode et select du début
active_politic = politic_first;

sprintf(dossier_scenario,DEFAULT_SCENARIO_FOLDER);

edit_grp_win_exists=OFF;
edit_pol_win_exists=OFF;
}

//-----------------------------------------

void day::next() //bon, ca fait pas les annees bissextiles mais faut pas deconner non plus
{
curday++;
if (month_counter++ == days_per_month) {month_id++; month_counter=1;}

switch(month_id) //d'apres defines.h
   {case  JANUARY:   days_per_month=31;   break; //NB de jours par mois
    case  FEBRUARY:  days_per_month=28;   break;
    case  MARCH:     days_per_month=31;   break;
    case  APRIL:     days_per_month=30;   break;
    case  MAY:       days_per_month=31;   break;
    case  JUNE:      days_per_month=30;   break;
    case  JULY:      days_per_month=31;   break;
    case  AUGUST:    days_per_month=31;   break;
    case  SEPTEMBER: days_per_month=30;   break;
    case  OCTOBER:   days_per_month=31;   break;
    case  NOVEMBER:  days_per_month=30;   break;
    case  DECEMBER:  days_per_month=31;   break;   }

if (month_id > 12) {month_id=1; year_counter++;}

 switch(month_id)
   { case  1:   month_name = "January" ;  break;
     case  2:   month_name = "February" ;  break;
     case  3:   month_name = "March" ;  break;
     case  4:   month_name = "April" ;  break;
     case  5:   month_name = "May" ;  break;
     case  6:   month_name = "June" ;  break;
     case  7:   month_name = "July" ;  break;
     case  8:   month_name = "August" ;  break;
     case  9:   month_name = "September" ;  break;
     case 10:   month_name = "October" ;  break;
     case 11:   month_name = "November" ;  break;
     case 12:   month_name = "December" ;  break;

     default:   break;
     }//fin de switch pour nom du jour

year=start_year+year_counter;


}//end of next_day function
void day::time_warp(int days_to_advance)
{
 int ttt=0;
 while (ttt++!=days_to_advance) {month_name="warping";
 next();}
}//end of next_day function

//pour ajouter une chaine au texte
void day::add_history(char str_received[255])
{

	if (strcmp(history_text, "stop_it")!=0)
	{//si c'est pas le premier événement du jour 
		strcat(history_text,"\n\t\t\t\t");
		strcat(history_text,str_received);
	}
	else
	{//si c'est le seul ou premier événément du jour
		sprintf(history_text,str_received);
	}

}

void day::app_dir()
{
  //tout ça pour trouver le dir de l'application, UN PEU LOURD!!! enfin...
  app_info info;
  BPath path;
  be_app->GetAppInfo(&info);  //infos sur l'app dont le directory
  BEntry tmp_entry(&info.ref);
  BEntry file_entry;
  tmp_entry.GetParent(&file_entry); //on revient en arrier car il y a le nom de l'exec!
  file_entry.GetPath(&path); 
  sprintf(dossier_app,path.Path()); //recupere le nom en string pour pouvoir le modifier après
  //------
}  	
///////////////////////////////////////////////////////
//************   FIN DE CLASSE DAY    *************//
///////////////////////////////////////////////////////

//fonction pour utiliser progressive Bmp par Edmund Vermeulen
//#include "ProgressiveBitmapStream.h"

BBitmap *day::FetchBitmap(char *filename, uint8 mode)
{
  
	BBitmap* pBitmap = BTranslationUtils::GetBitmap(filename);
	
	
	if (pBitmap)	
	return pBitmap;
	else
	{
	  fprintf(stderr, "\nERROR READING: %s , using empty 64x64 image",filename);
 		
	    BAlert* pAlert = new BAlert("file i/o error", filename, "OK");
		pAlert->Go();
		
         return new BBitmap(BRect(0,0,64,64), B_RGB32,false,false);
 
	}


  /*
	
//  fprintf(stderr, "\nFetching the bitmap: %s",filename);
  
  BFile file(filename, B_READ_ONLY);

//  fprintf(stderr, "\nFile created: %s",filename);
 
 uint8 dither=false;
 if (mode == 8) dither=true;

//POUR PROGRESSIVE
   //ProgressiveBitmapStream stream(0, 0, dither); //dither true

  //pour bbitmap stream standard
  BBitmapStream stream;    BBitmap *result = NULL; 

//  fprintf(stderr, "\nstream and bitmap created %s",filename);
 
 //pas la peine de displayer si pic trop petite...
 //stream.DisplayProgressBar(BPoint(200,200),"Loading bitmap...");
 
 BTranslatorRoster *roster = BTranslatorRoster::Default();

	if (roster==NULL)
	  fprintf(stderr, "\nroster created NULL :  %s",filename);
  
//  		else
  //			fprintf(stderr, "\nroster created OK:  %s",filename);
    
        if (roster->Translate(&file, NULL, NULL, &stream, 
            B_TRANSLATOR_BITMAP) < B_OK) 
{
	  fprintf(stderr, "\nERROR READING IMAGE: <%s> ",filename);
//         return new BBitmap(BRect(0,0,64,64), B_RGB32,false,false);
	 return NULL;
}


  //pour bbitmap stream standard
  stream.DetachBitmap(&result); 

  
  fprintf(stderr, "\nSUCCESS reading the bitmap: %s",filename);

  return result;
  
  //POUR PROGRESSIVE
  //stream.SetDispose(false);
  //return stream.Bitmap();
*/

}



/*
B_TRANSLATOR_BITMAP
Declared in: be/translation/TranslatorFormats.h 


*/

   void day::StoreTranslatorBitmap(BBitmap *bitmap, char *filename, uint32 type) 
   { 
      BTranslatorRoster *roster = BTranslatorRoster::Default(); 
      BBitmapStream stream(bitmap); // init with contents of bitmap 
      BFile file(filename, B_CREATE_FILE | B_WRITE_ONLY); 
   
      roster->Translate(&stream, NULL, NULL, &file, type); 
   }



BBitmap* day::load_bmp(char le_nom[255])
{ //toujours dans le dossier du scenar en cours et avec error check

   BAlert* alert;	 

   app_dir();
   char str[8192];
   char name[8192];
   sprintf(name,dossier_app); //recupere le nom en string pour le modifier

   strcat(name,dossier_scenario);        //on rajoute le dossier
   strcat(name,le_nom); //et le nom du fichier
	
  	BFile fich;
  	if (fich.SetTo(name,B_READ_ONLY)!=B_NO_ERROR)
  		{ 
  			sprintf(str,"For some reason, I could not load bitmap named:\n");
			strcat(str,name);
		    alert = new BAlert("",str,"oops..."); 
    		alert->Go();
		 }
  	else {  
  	 		return FetchBitmap(name,32) ;
		  }
 return NULL; //si ça a merdé 	
}


//----------------------

BRect day::find_win_pos(float width, float height)
{
	//trouve le point idéal pour poser la win
	BAlert *tmp;
	BPoint pt = tmp->AlertPosition(width, height); 
	BRect r;
	r.Set(pt.x, pt.y, pt.x+width, pt.y+height);
	return r;
}


void day::PlaySoundFile(const char *name)
{

	fprintf(stderr, "Playing sound %s",name);

	app_dir();
	char x[4096];
	sprintf(x,dossier_app);	
	strcat(x,dossier_scenario); //les slashes sont dedans.
	strcat(x,"sounds/");
	strcat(x,name);

//	printf("\nPath of sound being played: ");	printf(x);
			
	TheSounds.AddSound( 0, x );  // Load a sound and give it and ID of 42
	TheSounds.PlaySound( 0 );  // Start playing the sound  (this does NOT block)

	fprintf(stderr
	, "Sound played.");

}