#include "EditWindow.h" 

EditWindow::EditWindow(BRect frame,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(frame, "Edit Country Data", B_FLOATING_WINDOW,B_NOT_H_RESIZABLE | B_ASYNCHRONOUS_CONTROLS) 
{
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id; 
	Pol_pointer = Politic_id;
	
	jour->editWin=this; //pour pouvoir recevoir des messages
			
//-------------------------------------
	


	BRect rect;
	rect.Set(0,0,EDIT_X_SIZE-(2*B_V_SCROLL_BAR_WIDTH)-4,EDIT_Y_SIZE-B_V_SCROLL_BAR_WIDTH-2);
	ed_view = new EditorView(rect, B_FOLLOW_ALL |B_WILL_DRAW,
						  Ct_pointer,Grp_pointer,Pol_pointer,jour);

	BScrollView *scroll_view=new BScrollView("", ed_view, B_FOLLOW_ALL, 0, false, true);
	AddChild(scroll_view);

//par défaut les scroll bars vont jusqu'à 1000 donc faut les setter
BScrollBar *verti = scroll_view->ScrollBar(B_VERTICAL);

//le range de scroll est égal à la taille de la pic moins la partie affichée
verti->SetRange(0, EDIT_Y_SIZE-110); 

jour->infoWin->PostMessage(DRAW_INFO);
ed_view->SetEdit();


SetSizeLimits(EDIT_X_SIZE-B_V_SCROLL_BAR_WIDTH-3,EDIT_X_SIZE-B_V_SCROLL_BAR_WIDTH-3, //min max width 
         	  128, 2000);    //min max height

ed_view->SelectedCt(); 
 
}

EditWindow::~EditWindow()
{

if (jour->edit_grp_win_exists==ON) 
	{	grpWin->Close();
		jour->edit_grp_win_exists=OFF;
	}
	
jour->edit_mode=OFF;
jour->pause=OFF;
jour->game_started=ON;
jour->edit_menu->SetEnabled(false);
jour->mainWin->PostMessage(UPDATE_TITLE);
		
//surtout pas faire un Close() ici! On est déjà en train de killer la win
}

void EditWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what )
 	{
 	
		case SET_GRP_LIST_EDIT:
		ed_view->UpdateGroups(); 
		break;
		 	
 		case SET_EDIT:	
		ed_view->SetEdit(); //affiche les valeurs actuelles dans les cases
		break;

 		case EDIT_UPDATE:
 		ed_view->UpdateEdit(); //update les données d'après les cases
 		jour->infoWin->PostMessage(DRAW_INFO);
		//affiche le groupe actif dans edit grp win
		if (jour->edit_grp_win_exists==ON) jour->edit_grpWin->PostMessage(SET_GRP_EDIT);
  		break;
		
		case EDIT_CT_SELECT:
 		ed_view->SelectedCt();
 		break;
		
		case BUTTON_NEXT:
		if (jour->active_country == jour->country_last) jour->active_country=jour->country_first;
		else jour->active_country++;
		ed_view->SetEdit();
		jour->mainWin->PostMessage(SHOW_SELECT);
		jour->infoWin->PostMessage(DRAW_INFO);
	    break; 

 		case BUTTON_PREV:
		if (jour->active_country == jour->country_first) jour->active_country=jour->country_last;
		else jour->active_country--; //si on peut pas faire la suivante on recommence
		ed_view->SetEdit();
		jour->mainWin->PostMessage(SHOW_SELECT);
		jour->infoWin->PostMessage(DRAW_INFO);
	    break; 
	    
	    
 		case BUTTON_GEN: //genere une armée
 		Ct_pointer[jour->active_country]->set_army(); //génére valeurs par défaut
 		Ct_pointer[jour->active_country]->default_army(); //les mets...
 		ed_view->SetEdit();
		jour->infoWin->PostMessage(DRAW_INFO);
 		break;


		case BUTTON_ADD_GRP:
		 if (jour->group_last != MAX_GROUP) //min un grp
			{
				 rgb_color couleur= (rgb_color) {0,255,0,0}; //vert pétant
				 unsigned char nn=(jour->group_last)+1;
				 Grp_pointer[nn]  = new Group      (COMPUTER,"New Group",nn,couleur,PO_ANARCHY,NULL,jour);

				 	jour->group_last++;
		 			Ct_pointer[jour->active_country]->group = jour->group_last;

				ed_view->UpdateGroups();

		if (jour->edit_grp_win_exists==ON)
			{
			grpWin ->Lock();
			grpWin->ed_grp_view->SetGrpEdit();
			grpWin ->Unlock();
			}
		jour->mainWin->PostMessage(DRAW_ACTIVE_COUNTRY);

  		  }
		 else
		 {BAlert *alert = new BAlert("","This would exceed maximum number of groups allowed!","Oompf!");alert->Go();}
		 
  		break;

		case BUTTON_EDT_GRP:
		ed_view->SetEdit();	  		 		

		if (jour->edit_grp_win_exists==OFF) //si existe pas déja
		{
		jour->edit_grp_win_exists=ON;
		grpWin = new EditGrpWindow(Ct_pointer,Grp_pointer,Pol_pointer,jour);
		grpWin->ed_grp_view->SetGrpEdit();
		grpWin ->Lock();		
	    grpWin ->Show();		
 		grpWin ->Unlock();				
		}
		else beep();
		break;
		
		case BUTTON_DEL_GRP:
		
		if (jour->group_first != jour->group_last) //min un grp
						{
		char str[255];
		char str2[255];
		sprintf(str,"Confirm deletion of ");
		sprintf(str2,Grp_pointer[jour->active_group]->grp_name);
		strcat(str,str2);
		BAlert *alert = new BAlert("", str,"Cancel", "Go on"); 
		int32 button_index;
   
   			switch(button_index = alert->Go())
   					{
   					case 0:
   					//back to the jeu
   					break;
		
					case 1:
					//SUPPRESSION DU GROUPE
					//on copie le dernier groupe à la place du supprimé 
   					unsigned char grp     = jour->active_group;
   					unsigned char new_grp = jour->group_first; //pour l'instant
   					
   					
   					//pays du groupe détruits vers un autre groupe (new_grp)
   					unsigned char the_ctry = jour->country_first; //pour pointer dans list pays
					while (the_ctry != jour->country_last+1) 
						{
						 if (Ct_pointer[the_ctry]->group==grp) Ct_pointer[the_ctry]->group=new_grp;
						 the_ctry++;
						 }
   						//echange groupe avec le dernier groupe
   					
   					unsigned char keep_nb=Grp_pointer[grp]->nb; //on garde le nb du groupe
   					*Grp_pointer[grp]     = *Grp_pointer[jour->group_last]; 
   					Grp_pointer[grp]->nb=keep_nb; //on remet le meme numéro de groupe
   					
   					//pays du groupe last au nouvel emplacement
   					the_ctry = jour->country_first; //pour pointer dans list pays
					while (the_ctry != jour->country_last+1) 
						{
						 if (Ct_pointer[the_ctry]->group==jour->group_last) Ct_pointer[the_ctry]->group=keep_nb;
						 the_ctry++;
						 }
   					   					
					//mise à jour liste
		 			if (jour->group_last > jour->group_first) jour->group_last--;
		 			Ct_pointer[jour->active_country]->group = jour->group_first;
					
					//TRes important de locker sinon crash
					ed_view->UpdateGroups();
					if (jour->edit_grp_win_exists==ON)
					{
						grpWin ->Lock();
						grpWin->ed_grp_view->SetGrpEdit();
						grpWin ->Unlock();
					}
		 			
					jour->mainWin->PostMessage(MENU_EDIT_REFRESH);
					break;
		
					}
			}//fin if min deux grp
			 else
		 {BAlert *alert = new BAlert("","You need at least one group!","Oompf!");alert->Go();}
		 
		break;//fin button DEL	
		

 		 		
		default:
   		// Call inherited if we didn't handle the message
   		BWindow::MessageReceived(message);
        break;
		}//end switch

}//fin message received

void EditWindow::NotImplemented()
{
   	  	BAlert *alert = new BAlert("","Sorry, still not Implemented","Oompf!");alert->Go();
 
}




//**********************************************************************
//**********************************************************************
//**********************************************************************
//**********************************************************************



EditGrpWindow::EditGrpWindow(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(jour->find_win_pos(EDIT_GRP_X_SIZE,EDIT_GRP_Y_SIZE),
						  "Edit Group", B_FLOATING_WINDOW,  B_NOT_RESIZABLE | B_NOT_ZOOMABLE) 
{
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
	
	jour->edit_grpWin=this; //pour pouvoir recevoir des messages
	ed_grp_view = new EditorGrpView(Bounds(), B_FOLLOW_ALL |B_WILL_DRAW,
						  Ct_pointer,Grp_pointer,Pol_pointer,jour);
	AddChild(ed_grp_view);

    ed_grp_view->SetGrpEdit(); //met les valeurs actuelles dans les cases
	jour->edit_grp_win_exists=ON;
	
	
}

EditGrpWindow::~EditGrpWindow()
{
jour->edit_grp_win_exists=OFF;

if (jour->edit_pol_win_exists==ON) 
	{	polWin->Close();
		jour->edit_pol_win_exists=OFF;
	}
	

}


void EditGrpWindow::MessageReceived(BMessage *message)
{


	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what )
 	{
	
		case SET_COMPUTER_PLAYER: 	Grp_pointer[jour->active_group]->player = COMPUTER; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_01: 		Grp_pointer[jour->active_group]->player = PLAYER_01; 
		jour->player_group = jour->active_group;		
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_02: 		Grp_pointer[jour->active_group]->player = PLAYER_02; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_03: 		Grp_pointer[jour->active_group]->player = PLAYER_03; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_04: 		Grp_pointer[jour->active_group]->player = PLAYER_04; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_05: 		Grp_pointer[jour->active_group]->player = PLAYER_05; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_06: 		Grp_pointer[jour->active_group]->player = PLAYER_06; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_PLAYER_07: 		Grp_pointer[jour->active_group]->player = PLAYER_07; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
	
		case SET_PLAYER_08: 		Grp_pointer[jour->active_group]->player = PLAYER_08; 
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
		
		case SET_GRP_EDIT:	
		ed_grp_view->SetGrpEdit(); //affiche les valeurs actuelles dans les cases
		break;

		case UPDATE_GRP_EDIT:	
		ed_grp_view->UpdateGrpEdit();
		break;
		
		case GRP_COLOR_CHANGED:
		ed_grp_view->UpdateGrpEdit(); //FAUT UPDATER LES DATAS SI ON VEUT VOIR L'effet!
		jour->mainWin->PostMessage(new BMessage (MULTIPLY_ALL));
		jour->infoWin->PostMessage(new BMessage (DRAW_INFO));
		break;
	
		case SET_GRP_LIST_EDIT:
		ed_grp_view->UpdateGrpEdit(); //FAUT UPDATER LES DATAS SI ON VEUT VOIR L'effet!
		ed_grp_view->SetGrpEdit(); 
		jour->editWin->PostMessage(SET_GRP_LIST_EDIT);
  		break;

		case SET_POL_LIST_EDIT:
		ed_grp_view->UpdatePolitics(); 
		break;

 		case EDIT_GRP_UPDATE:
  		ed_grp_view->UpdateGrpEdit(); //met valeurs de l'écran dans le grp
		jour->infoWin->PostMessage(DRAW_INFO);
		//affiche le groupe actif dans edit grp win
		if (jour->edit_pol_win_exists==ON) jour->edit_polWin->PostMessage(SET_POL_EDIT);
  		break;
		
		break;
		
		case FLAG_LOAD:
 				 jour->app_dir();
				  flag_load = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,NULL,false,true);
				 flag_load->Window()->SetTitle("Choose a flag file (80 x 40)");
				 flag_load->Window()->SetFeel(B_FLOATING_APP_WINDOW_FEEL);//DEVANT TOUT
				 char str[2048];
				 sprintf(str,jour->dossier_app);
				 strcat(str,jour->dossier_scenario);
				 flag_load->SetPanelDirectory(str);
				jour->is_flag_load = ON; //sinon refsreceived le prend pour une backup

				 flag_load->Show();
 		 break;
 		 

		//------------------------------------
		
		case BUTTON_ADD_POL:
		 if (jour->politic_last != MAX_POLITIC) 
			{
				 unsigned char nn=(jour->politic_last)+1;
				 Pol_pointer[nn]  = new Politic ("New Politic",nn);
   			 	 jour->politic_last++;
		 		 Grp_pointer[jour->active_group]->politic = jour->politic_last;
 
				 ed_grp_view->UpdatePolitics();

		if (jour->edit_pol_win_exists==ON)
			{
			polWin ->Lock();
			polWin->ed_pol_view->SetPolitic();
			polWin->ed_pol_view->SetPolEdit();
			polWin ->Unlock();
			}

  		  }
		 else
		 {BAlert *alert = new BAlert("","This would exceed maximum number of politics allowed!","Oompf!");alert->Go();}
		 
  		break;

		case BUTTON_EDT_POL:
		ed_grp_view->SetGrpEdit();	  		 		

		if (jour->edit_pol_win_exists==OFF) //si existe pas déja
		{
		jour->edit_pol_win_exists=ON;
		polWin = new EditPolWindow(Ct_pointer,Grp_pointer,Pol_pointer,jour);
		polWin->ed_pol_view->SetPolEdit();
		polWin ->Lock();		
	    polWin ->Show();		
 		polWin ->Unlock();				
		}
		else beep();
		break;
		
		case BUTTON_DEL_POL:
		
		if (jour->politic_first != jour->politic_last) //min un grp
						{
		char str[255];
		char str2[255];
		sprintf(str,"Confirm deletion of ");
		sprintf(str2,Pol_pointer[jour->active_politic]->politic_name);
		strcat(str,str2);
		BAlert *alert = new BAlert("", str,"Cancel", "Go on"); 
		int32 button_index;
   
   			switch(button_index = alert->Go())
   					{
   					case 0:
   					//back to the jeu
   					break;
		
					case 1:
					//SUPPRESSION DU GROUPE
					//on copie le dernier pol à la place du supprimé 
   					unsigned char pol     = jour->active_politic;
   					unsigned char new_pol = jour->politic_first; //pour l'instant
   					
   					
   					//groupe de la pol détruits vers un autre politic (new_pol)
   					unsigned char the_grp = jour->group_first; //pour pointer dans list pays
					while (the_grp != jour->group_last+1) 
						{
						 if (Grp_pointer[the_grp]->politic==pol) Grp_pointer[the_grp]->politic=new_pol;
						 the_grp++;
						 }
   						//echange groupe avec le dernier groupe
   					
   					unsigned char keep_nb = Pol_pointer[pol]->nb_pol; //on garde le nb du groupe
   					*Pol_pointer[pol]     = *Pol_pointer[jour->politic_last]; 
   					Pol_pointer[pol]->nb_pol=keep_nb; //on remet le meme numéro de groupe
   					
   					//pays du groupe last au nouvel emplacement
   					the_grp = jour->group_first; //pour pointer dans list pays
					while (the_grp != jour->group_last+1) 
						{
						 if (Grp_pointer[the_grp]->politic==jour->politic_last) Grp_pointer[the_grp]->politic=keep_nb;
						 the_grp++;
						 }
   					   					
					//mise à jour liste
		 			if (jour->politic_last > jour->politic_first) jour->politic_last--;
		 			Grp_pointer[jour->active_group]->politic = jour->politic_first;
					
					//TRes important de locker sinon crash
					ed_grp_view->UpdatePolitics();
					if (jour->edit_pol_win_exists==ON)
					{
						polWin ->Lock();
						polWin->ed_pol_view->SetPolitic();
						polWin->ed_pol_view->SetPolEdit();
						polWin ->Unlock();
					}
					break;
		
					}
			}//fin if min deux grp
			 else
		 {BAlert *alert = new BAlert("","You need at least one politic!","Oompf!");alert->Go();}
		 
		break;//fin button DEL	
		
		
 		 		
		default:
   		// Call inherited if we didn't handle the message
   		BWindow::MessageReceived(message);
        break;
		}//end switch

}//fin message received


void EditWindow::FrameResized(float width, float height)
{
//remet la taille possible des scrollbars au nécessaire
ed_view->ScrollBar(B_VERTICAL)->SetRange(0, (ed_view->Bounds().Height())-height);

}



EditPolWindow::EditPolWindow(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(jour->find_win_pos(EDIT_POL_X_SIZE,EDIT_POL_Y_SIZE),
						  "Edit Politic", B_FLOATING_WINDOW, B_NOT_H_RESIZABLE | B_NOT_ZOOMABLE) 
{
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
	
	jour->edit_polWin=this; //pour pouvoir recevoir des messages
	ed_pol_view = new EditorPolView(Bounds(), B_FOLLOW_ALL |B_WILL_DRAW,
						  Ct_pointer,Grp_pointer,Pol_pointer,jour);
	AddChild(ed_pol_view);

    ed_pol_view->SetPolEdit(); //met les valeurs actuelles dans les cases
	jour->edit_pol_win_exists=ON;
	
	
}

EditPolWindow::~EditPolWindow()
{
jour->edit_pol_win_exists=OFF;

}


void EditPolWindow::MessageReceived(BMessage *message)
{


	// Print the message to see its contents
	message->PrintToStream();

 	switch ( message->what )
	{
		int8 val;		

		case SET_POL_EDIT:	
		ed_pol_view->SetPolEdit(); //affiche les valeurs actuelles dans les cases
		break;

		case UPDATE_RELATIONS:	
		ed_pol_view->SetPolitic(); 
		ed_pol_view->UpdatePolEdit();
		jour->edit_grpWin->PostMessage(new BMessage(SET_POL_LIST_EDIT));
		break;

		case UPDATE_POL_EDIT:	
		ed_pol_view->UpdatePolEdit();
		jour->edit_grpWin->PostMessage(new BMessage(SET_POL_LIST_EDIT));
		break;
	
		case BECOMES_FRIEND:
		message->FindInt8("val",&val);
		Pol_pointer[jour->active_politic]->relation[val] = FRIEND;
		break;	
		
		case BECOMES_NEUTRAL:
		message->FindInt8("val",&val);
		Pol_pointer[jour->active_politic]->relation[val] = NEUTRAL;
		break;	
		
		case BECOMES_ENNEMY:
		message->FindInt8("val",&val);
		Pol_pointer[jour->active_politic]->relation[val] = ENNEMY;
		break;	
		
		default:
   		// Call inherited if we didn't handle the message
   		BWindow::MessageReceived(message);
        break;
		}//end switch

}//fin message received

