#include "Main.h"

//for cast_as
#include <ClassInfo.h>



int main()
{	

fprintf(stderr, "\nStarting W6...");

day *compteur;
compteur = new day(1970); //année de départ
compteur->pause=ON;
//Création de tableaux pays, groupes, politiques et weapons;
Weapon   *Weapon_id [MAX_WEAPON];
Politic  *Politic_id [MAX_POLITIC];      //tableau de pointeurs sur les politics
Group    *Group_id   [MAX_GROUP];      		//tableau de pointeurs sur les Groupes
Country  *Country_id [MAX_COUNTRY]; //tableau de pointeurs sur les pays
                                    //chaque pays est a la position definie
                                    //par son num de couleur dans la palette

fprintf(stderr, "\nCreating and launching application object...");

	MainApplication	myApplication(Country_id,Group_id,Politic_id, Weapon_id,compteur); 
	myApplication.Run();
 
	return(0);
}



//-----------------------------------------------------------------------
// MainApplication constructor
MainApplication::MainApplication(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
								 Politic *Politic_id[MAX_POLITIC],Weapon *Weapon_id[MAX_WEAPON], day *compteur)
		  		  : BApplication("application/x-vnd.slema-w6")
{
 
////////////////////////////////////////////////////////////////////////////
	jour=compteur;

	Ct_pointer  = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
	Wpn_pointer = Weapon_id;

	fprintf(stderr,"\nW6 app ok.");

}

void MainApplication::ReadyToRun()
{

	fprintf(stderr,"\nMain Application ReadyToRun()...");


	jour->main_alert = new BAlert("","Startup process... please wait.", "Crash it!"); 
	BTextView *tmp; //pointeur sur le texte du main_alert win
	tmp=jour->main_alert->TextView();
    jour->main_alert->Go(NULL); //NULL pour run asynchrone (on attend pas la réponse)


////////////////////////////////

//en attendant de pouvoir loader les scenars

	fprintf(stderr,"\nSettings defaults....");

#include "init_weapon.cpp"   //creation des armes
#include "init_grp.cpp"   //creation des Groupes et politiques
#include "init.cpp"       //creation des pays
#include "data.cpp"       //donnees des pays (c'est enorme!!!)

////////////////////////////////
	fprintf(stderr,"\nSettings defaults... DONE");

  	BRect aRect;	
 	unsigned char temp_ctry;
   			
   //Fenetre principale
	aRect.Set(8, 24, WIN_X_SIZE+8,WIN_Y_SIZE+24);
	mainWindow = new MainWindow(aRect,Ct_pointer,Grp_pointer,Pol_pointer,jour);
	
	aRect.Set(32, 100, 32+INFO_X_SIZE, 100+INFO_Y_SIZE);
	infoWindow = new InfoWindow(aRect,Ct_pointer,Grp_pointer,Pol_pointer,jour);

	jour->infoWin=infoWindow; //pour pouvoir envoyer des messages depuis


	fprintf(stderr,"\nWarping countries from 1970...");
   //day passed_FAKE jusqu'au futur
   //day_passed_FAKE est _beaucoup_ plus rapide car il fait que la population 
   	jour->main_alert->Lock();
    tmp->SetText("Warping countries' data from 1970 to 2066...");
	jour->main_alert->Unlock();

	
//données de 1970 faut avancer dans le temps
   unsigned long jump_to_future;
   
   jump_to_future=0;
	
       while(jump_to_future!= (2066-1970)*365)
       	   {
           temp_ctry = jour->country_first;
           while (temp_ctry != jour->country_last+1)
           			{
           			Ct_pointer[temp_ctry]->day_passed_fake();
          			temp_ctry++;
           			} 
           	jour->next();
			jump_to_future++;
			}

   jour->main_alert->Lock();
   jour->main_alert->Close();

//----------------------------------------------------------------------------------------


	mainWindow->SetTitle("What Went Wrong? It's a World Wide War!"); //pour la barre à droite meme si on voit plus le titre
//	mainWindow->Zoom();

	jour->mainWin=mainWindow; //pour pouvoir envoyer des messages depuis

	fprintf(stderr,"\nBefore First multiply...");

	if (mainWindow->inside_view!=NULL)
	{
		fprintf(stderr,"\nFirst multiply...");
		mainWindow->inside_view->MultiplyAll();
	}
	
	fprintf(stderr,"\nShow MainWindow..."); 
	
	mainWindow->Lock();	
	mainWindow->Show();
 	mainWindow->Unlock();	

	fprintf(stderr,"\nShow InfoWindow...");

	infoWindow->Lock();	
	infoWindow->Show();
	infoWindow->Unlock();	

	fprintf(stderr,"\nStarting runMe...");
 	
 	//classe qui tourne en permanence et qui fait les daypassed (et par conséquent, les battle etc. 
	run_me = new Running(Ct_pointer,Grp_pointer,Pol_pointer,Wpn_pointer,jour);

	runWin = new BWindow(BRect(0,0,0,0), "W6 time run", B_TITLED_WINDOW,  B_NOT_RESIZABLE); 
	runWin->AddChild(run_me); //sinon le pulse fonctionne pas...					  
	runWin->Lock();  
	runWin->Show(); //faut faire show pour lancer le pulse dans les views
	runWin->Hide(); //quitte à hider la window ensuite
	runWin->Unlock();  

	fprintf(stderr,"\nStarting ChoseWindow...");

	ChooseWindow *firstWindow = new ChooseWindow(Ct_pointer,Grp_pointer,jour);
	firstWindow->Lock();  
	firstWindow->Show();  
	firstWindow->Unlock();   
	jour->PlaySoundFile("startup.aiff");
 
   
//----------------------------------------------------------------------------------------

}//fin mainappplication

bool MainApplication::QuitRequested()
{//c'est le QuitRequested de MainApplication qui reçoit les raccourcis clavier (CMD+Q)

  BAlert *alert = new BAlert("", 
                     "Hey you! Not so fast! Don't you even wish to Save Game before quitting?", 
                     "Cancel", "Quit", "Save"); 
   int32 button_index;

 
   switch(button_index = alert->Go())
   {
   //les boutons ont toujours les valeurs 0,1,2 (trois boutons max)
   case 0:
   //back to the jeu
   break;
   	
   case 1:
	be_app->Quit();	
   	return(true);
   	
    break;
   
   case 2:
	BAlert *alert = new BAlert("","In fact, you cannot save","Yurgl?"); 
	alert->Go();
    break;
    
	}
	return false;

}


void MainApplication::MessageReceived(BMessage *message)
{


	// Print the message to see its contents
	message->PrintToStream();
//	BAlert *alert;
 	switch ( message->what ){

			case B_SAVE_REQUESTED://le load est dans RefsReceived()
			//**************************************************************
			// SAVE
			//**************************************************************

			entry_ref ref;
			message->FindRef("refs", &ref); //cherche s'il y a nom file dans msg et le met dans ref
			BEntry entry(&ref); 
			
			char txt[255];
  			entry.GetName(txt);
			BAlert *xlert = new BAlert("",txt,"Alors?"); 
  		    xlert->Go();
  		

   BMessage msg_dat; 
   BBitmap *tmp_bitmap = new BBitmap(BRect(0,0,320,200),B_CMAP8);
   
   //*********************************************************
   
   //ON SAUVE L'OBJET DANS UN MESSAGE
   tmp_bitmap->Archive(&msg_dat);
	
	//faut faire ces deux a l'enregistrement et au chargement (ici on fait qu'une fois pour l'essai)
   long size = msg_dat.FlattenedSize();
   char *flat_buffer= (char*) malloc(size); //on alloue de la ram pour stocker l'objet à sauver

	
  msg_dat.Flatten(flat_buffer,size); //Faut aplatir avant de pouvoir sauver...

  
  //on enregistre le fichier (on le crée au besoin)

 // sprintf(txt,"daube.dab");
  BFile fich= BFile(txt, B_CREATE_FILE | B_WRITE_ONLY);
 
  //si erreur d'écriture ou lecture retour est négatif donc erreur
  if (fich.Write(flat_buffer, size) < 0) 
 	{
  		   BAlert *alert = new BAlert("","Erreur d'enregistrement","oops..."); 
  		   alert->Go();
  		
  		} 


/*
			BMessage data_msg; //message ou stocker l'objet sauvé avant Unflatten et Cast dans sa forme originelle
			entry_ref ref;
			
			//cherche s'il y a nom file dans message et le met dans ref
			message->FindRef("refs", &ref); 
			BEntry entry(&ref); 
			
			//ON SAUVE L'OBJET DANS UN MESSAGE

	  		Ct_pointer[FRANCE]->Archive(&data_msg);
			long size = data_msg.FlattenedSize();  		//taille objet aplati
			char *flat_buffer= (char*) malloc(size);
   			data_msg.Flatten(flat_buffer,size); 			//Faut aplatir avant de pouvoir sauver...
			
			BFile *fich = new BFile();
  			fich->SetTo(&entry,B_CREATE_FILE);
			

			
		    //si erreur d'écriture ou lecture retour est négatif donc erreur
  			if (fich->Write(flat_buffer, size) < 0) 
		 	{  alert = new BAlert("","Erreur d'enregistrement","oops..."); 
  		  	alert->Go(); }  

*/
	   }//fin switch

}//fin message received


void MainApplication::RefsReceived(BMessage *message)
{

if (jour->is_flag_load==ON)
{
			
			//load du drapeau

			entry_ref ref;
			message->FindRef("refs", &ref);
			BEntry entry(&ref); 
			char txt[255];
			entry.GetName(txt);


			//BAlert * alert = new BAlert("",txt,"Do it"); alert->Go();
    				
			//le dossier app et scenar sont rajoutes dans load_bmp
			sprintf(Grp_pointer[jour->active_group]->flag_file_name,txt);
			Grp_pointer[jour->active_group]->load_bmp();
			
			jour->editWin->Show();	jour->edit_grpWin->Show(); //parce-qu'on les a cachés pour afficher le filepanel
			jour->infoWin->PostMessage(DRAW_INFO);
			jour->edit_grpWin->PostMessage(SET_GRP_EDIT);
			
			}
else {
			
			BAlert *alert;

			//**************************************************************
			// LOAD
			//**************************************************************
			entry_ref ref;
			message->FindRef("refs", &ref); //cherche s'il y a nom file dans msg et le met dans ref
			BEntry entry(&ref); 
			char txt[255];
			entry.GetName(txt);

			BMessage msg; //message ou stocker l'objet sauvé avant Unflatten et Cast dans sa forme originelle

			BFile fich;
  			fich.SetTo(&entry,B_READ_ONLY);
  			off_t size; //type données pour taille (offset, pas ssize_t)
  			fich.GetSize(&size); 
  			char *flat_buffer= (char*) malloc(size); //on alloue de la ram pour stocker l'objet à sauver

			//on le charge
  			if (fich.Read(flat_buffer, size) < 0)
  				{
  		   		alert = new BAlert("","Erreur de chargement","oops..."); 
  		   		alert->Go();
  		 		} 
 
 			 //on récupère l'objet dans le msg et on le réassigne au type bitmap (class BBitmap)
  			 msg.Unflatten(flat_buffer);
  			 BArchivable *archived_data = instantiate_object(&msg); 

//ATTENTION CA MERDE SI C'est pas le bon type!
			//la ça restaure un bmp faut faire avec country, group etc.
   			if ( archived_data ) //si pas null
   			{  
 			   	Lock();
 			   	Ct_pointer[USA] = cast_as(archived_data, Country);
       			Unlock();
		    }
			delete flat_buffer; //un peu d'économie	
			delete archived_data;
	
    //*********************************************************
   
   
   char str[1023];
   char str2[255];

   sprintf(str,"File name: ");
   sprintf(str2,txt);
   strcat(str,str2);
   sprintf(str2,"\nName: ");
   strcat(str,str2);
   sprintf(str2,Ct_pointer[USA]->name);   
   strcat(str,str2);
    
   alert = new BAlert("",str, "Daube"); 
   alert->Go();
		  		
	}

jour->is_flag_load=OFF;

}





Running::Running(Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC],Weapon *Weapon_id[MAX_WEAPON], day *compteur) :
	BView(BRect(0,0,0,0),"Running Pseudo View", Flags() | B_PULSE_NEEDED,B_WILL_DRAW)
{
//Cette classe est dérivée de running juste pour avoir le pulse...
//rien ici cette classe n'est là que pour pulser...
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
	Wpn_pointer = Weapon_id;
	jour=compteur;
	
}


void Running::Pulse()
{

if (jour->pause != ON) 
	{
	
	
		if (jour->step-- ==0)
		{
		uint32 i=0;
		uint32 to_reach=jour->jump_days; //PAs mettre directement jump_days dans la boucle
										 //car s'il est change en plus petit pendant la boucle crash puisque s'arrete plus
				
				do {  			
				  //DAY PASSED A INTERVALLE REGULIER
				  jour->next();
				  unsigned char temp_ctry = jour->country_first;
  				  while (temp_ctry != jour->country_last+1) 
  				  {Ct_pointer[temp_ctry]->day_passed();
  				  temp_ctry++;}
			 	 }while (i++!=to_reach);	
		jour->step=jour->day_step; //on recommence dans x pulses...
		jour->infoWin->PostMessage(DRAW_INFO);


		}

	}
}//fin pulse infoview
//----------------------------------------------
//----------------------------------------------
