#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include "day.h"
#include "country.h"
#include "group.h"
#include "def_col.h" //POUR GRP_X
#include "EditWindow.h"
#include "MainView.h"
#include "MapView.h"
#include "EditorView.h"
#include "HistoryView.h"

#define ZOOM_200 'z200'
#define ZOOM_150 'z150'
#define ZOOM_100 'z100'
#define ZOOM_75 'zm75'
#define ZOOM_50 'zm50'



#include "PopWindow.h"

//-----------------------------------	

class MainWindow : public BWindow {
public:
			MainWindow(BRect frame,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur);

virtual void 	MessageReceived(BMessage *message);
void My_AboutBox();
void Restart();
void OpenHelp();
float mb_height; //pour taille menubar

BuyWindow		*buyWindow;	
OrderWindow		*setWindow;	
SpeedWindow		*speedWindow;
EditWindow		*editWindow;

void ShortCuts(BMessage *msg);
virtual void FrameResized(float width, float height);


		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic	**Pol_pointer;
					
BMenuBar	*menubar; 
BMenuItem 	*paintmode; //car le texte change pour celui-ci
//les vues	
EditorView	*e_view;
BScrollView	*scroll_view;
MapView	*inside_view; 

HistoryView	*h_view; 
PowerView *power_view;
BView		*history_parent_view; 

BScrollBar *history_v_scroll;
BFilePanel *panneau_load;
BFilePanel *panneau_save;
	void NotImplemented();
private:
		
};


#endif //Main_WINDOW_H

