#ifndef Map_VIEW_H
#define Map_VIEW_H

#include "def_col.h"
#include "day.h"
#include "PopWindow.h"

class	MapView : public BView {
public:

		BBitmap		*final_bitmap;
		BBitmap		*frontier_bitmap;
		BBitmap		*bump_bitmap;

		BRect		selection;

		uchar		frontier_palette[256*3]; //couleurs des pays frontier_bitmap
		uchar		bump_palette[256*3]; //couleurs du bump (gris


   //  	TxtView	*pos_view;

virtual		void		Pulse();

		day		*jour;
		Country **Ct_pointer;	  
		Group	**Grp_pointer; 
		Politic **Pol_pointer; 
		BRect	bitmap_rect;
		
		float pause_angle;
		bool initDone;
		
	unsigned char *gray_ptr,*color_ptr,*full_ptr;
	unsigned char *gray_ptr_start,*color_ptr_start,*full_ptr_start;

		
		MapView(BRect r, Country **Country_id,Group **Group_id, Politic **Politic_id, day *compteur);
virtual	~MapView();

void UpdateTitle();

virtual	void		AttachedToWindow();
virtual	void		Draw(BRect);
		void	MouseDown(BPoint where);
		void 	MouseUp(BPoint point);
		virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
void 			Multiply(BRect la_zone);
void 			MultiplyAll();
void				Init();
void 			ShowSelect();
void 			PreparePics();
void 			ShowTroops();
void 			ShowLineAndName();
unsigned char 	SelectCountry(BPoint pix);

void CountriesChosen();

SendWindow	*sendWindow;


			BPoint start,end;
			BRect v_rect;
			BRect old_line_rect;
			BPoint delta;
			uint32 buttons;
void		update_map_palette();

void		set_gray_palette(); //celui-là on le fait qu'une fois au début et fertig
void		set_frontier_palette(unsigned char which_color,
                             unsigned char rval, unsigned char gval,unsigned char bval); 
bool dragging, dragging_view;
uint8 previous_ct; 
uint16 result;
uint8 agressor,victim; 
bool country_selected;
uint8 tab_multiply[256][256];
};

#endif
