#include "def_col.h"
#include "group.h"


//---------------- Constru cteurs Groupe ----------------//
Group::Group(unsigned char pl,char g_name[255], unsigned char numero, rgb_color col, unsigned char polit,char fname[255], day *compteur)
{
	jour=compteur;

	sprintf(grp_name,g_name);
	nb=numero;
	grp_color=col; 
	politic=polit;
	player=pl;
	sprintf(flag_file_name,fname); //nom de fichier utilisé plus tard
	grp_power=0; 
	power_percent=0; 
	active=ON;


	BRect bitmap_rect;
	bitmap_rect.Set(0,0,FLAG_X_SIZE-1,FLAG_Y_SIZE-1);
	flag_ptr = new BBitmap(bitmap_rect, B_RGB_32_BIT);

	//par défaut rempli gris sombre
	unsigned char *bits;
	bits = (unsigned char *)flag_ptr->Bits(); 
	unsigned int t=0;
	while (t!=FLAG_X_SIZE*FLAG_Y_SIZE*4)
	{
		bits++; 
		*bits=100; 
		t++;
	} 
	load_bmp();	

}

//---------------- Fonctions Groupe ----------------//



void Group::load_bmp()
{ 

	if (strlen(flag_file_name)==0)
	{
  		fprintf(stderr,"\nGroup with no flag:  <%s>",grp_name);
  		flag_ptr = new BBitmap(BRect(0,0,FLAG_X_SIZE-1,FLAG_Y_SIZE-1), B_RGB32);
		return;
	}
	
	char str[8192];
	BAlert* alert;	 


   jour->app_dir();
   char name[2048];
   sprintf(name,jour->dossier_app); //recupere le nom en string pour le modifier

   strcat(name,jour->dossier_scenario);        //on rajoute le dossier
   strcat(name,"flags/");
   strcat(name,flag_file_name); //et le nom du fichier
	
	fprintf(stderr,"\nLoading group flag:  <%s>",name);
	
  		 
  	BFile fich;
  	if (fich.SetTo(name,B_READ_ONLY)!=B_NO_ERROR)
  		{ 
  			sprintf(str,"For some reason, I could not load bitmap named:\n");
			strcat(str,name);
		    alert = new BAlert("",str,"oops..."); 
    		alert->Go();
		 }
  	else {  
  	 	//	sprintf(str,"Attempting to load bitmap named:\n");
		//	strcat(str,name);
		//	alert = new BAlert("",str,"Do it"); 
    	//	alert->Go(); 
			flag_ptr = jour->FetchBitmap(name,32) ;}
  	
  	if (flag_ptr==NULL) flag_ptr = new BBitmap(BRect(0,0,FLAG_X_SIZE-1,FLAG_Y_SIZE-1), B_RGB32);
} 


//---------------- Constructeurs Politic ----------------//
Politic::Politic(char the_name[255], unsigned char num)
{
	sprintf(politic_name,the_name);
	nb_pol=num;
	active=ON;

	repression=0;
	propaganda=0;

	//par défaut on est amis avec tout le monde (donc pas de combat)
	//on peut etre soit, FRIEND, ENNEMY, NEUTRAL
	//une fois qu'on a plus d'ennemi on attaque les neutral.
	int ttt=0;
	while (ttt!=255)
	{
		relation[ttt]=FRIEND; //relation avec autres pays
		ttt++;
	}

}
